#!/bin/bash

on_die()
{
    # print message
    #
    echo "Dying..."

    # Need to exit the script explicitly when done.
    # Otherwise the script would live on, until system
    # realy goes down, and KILL signals are send.
    #
    WPID=`pidof w_scan`
    kill -9 $WPID
    exit 0
}

# Execute function on_die() receiving TERM signal
#
#trap 'on_die' TERM
trap 'on_die' SIGTERM

FLAG=3
COUNTRY="US"
if [ "$1" = "ota" ]; then
    FLAG=1
fi
if [ "$2" ]; then
    COUNTRY="$2"
fi

echo "Scanning channels..."
DEVICE_TYPE=`/netpulse/bin/n5i-sys which-tv-device`
if [ "$DEVICE_TYPE" == "HVR950Q" ]; then
    w_scan -c US -A $FLAG -f c -X > /tmp/channels.conf.1 &
fi
if [ "$DEVICE_TYPE" == "HVR900H" ]; then
    w_scan -c $COUNTRY -f t -X > /tmp/channels.conf.1 &
fi

SERVICE='w_scan'
RUNNING=`ps ax | grep -v grep | grep $SERVICE`
while [ "$RUNNING" != "" ] ; do
  sleep 1
  RUNNING=`ps ax | grep -v grep | grep $SERVICE`
done

cat /tmp/channels.conf.1 | sed '/^:/s/:/no_name:/' > /tmp/channels.conf.2
cat /tmp/channels.conf.2 | grep -v service_id > /tmp/channels.conf.3
sort -nt: -k 1 /tmp/channels.conf.3 > /netpulse/etc/channels.conf
sed -i 's/VSB_8/8VSB/' /netpulse/etc/channels.conf 
echo "Scanning complete"

rm -f /tmp/channels.*
