#!/bin/bash
#
# Description:
#
# stlaunch.sh script.
# script to launch the Netpulse application on StarTrac
#
# Author: Jeff Mroczkowski
#

export NETPULSE_ROOT=/npboot/netpulse
export LD_LIBRARY_PATH=${NETPULSE_ROOT}/lib:/var/lib/apt
export QT_QWS_FONTDIR=${NETPULSE_ROOT}/lib/fonts
export QT_PLUGIN_PATH=${NETPULSE_ROOT}/lib/plugins
export QWS_MOUSE_PROTO="NetpulseInput:/dev/input/by-path/serio-1-event-"
export POINTERCAL_FILE="${NETPULSE_ROOT}/data/pointercal"

killall ${NETPULSE_ROOT}/bin/master
killall ${NETPULSE_ROOT}/bin/gui 
sleep 1

LOGROTATE_CONF=${NETPULSE_ROOT}/tmp/logrotate.netpulse
LOGROTATE_STATE=${NETPULSE_ROOT}/tmp/logrotate.state
if [ -f $LOGROTATE_CONF ] ; then
    /usr/sbin/logrotate $LOGROTATE_CONF -s $LOGROTATE_STATE
fi

if [ -f ${NETPULSE_ROOT}/bin/cleanq ]; then
    ${NETPULSE_ROOT}/bin/cleanq
fi

for i in "/tmp/*.pid" ""; do
    shm_creator_pid=999999999
    shm_creator_pid=`cat $i`
    shm_segment_id=`ipcs -mp | grep $shm_creator_pid | awk '{print $1}'`
    if [ "x${shm_segment_id}" != "x" ] ; then
        ipcrm -m $shm_segment_id
    fi
done 

# if file exists and says on
ONOFF=`cat /boot/.config/netpulse`
if [ "$ONOFF" == "on" ] ; then
    echo "Netpulse on - running"
    ${NETPULSE_ROOT}/bin/master "$@" &
else
    echo "Netpulse off - not starting"
fi
