gigyaObj = {
/**
 * Constants
 */	
	/**
	 * Global flag to indicate whether Facebook/Gigya is enabled
	 */
	ENABLED : true,
	
	/**
	 * List of providers (currently supported by NP)
	 */
	PROVIDERS : {
		FACEBOOK : 'facebook'
	},
	
	/**
	 * List of fields accessible via getUserData()
	 */
	FIELDS : {
		GIGYA_ID : 'gigya_id',
		
		USER : {
			UID : 'UID',	// string
			IS_SITE_UID : 'isSiteUID',	// Boolean 
			PROVIDERS : 'providers',	// array of strings
			NICKNAME : 'nickname',	// string
			PHOTO_URL : 'photoURL',	// string
			FIRST_NAME : 'firstName',	// string
			LAST_NAME : 'lastName',	// string
			GENDER : 'gender',	// string ('m'/'f')
			BIRTH_DAY : 'birthDay',	// number
			BIRTH_MONTH : 'birthMonth',	// number
			BIRTH_YEAR : 'birthYear',	// number
			EMAIL : 'email',	// string
			PROXIED_EMAIL : 'proxiedEmail',	// string
			COUNTRY : 'country',	// string
			STATE : 'state',	// string
			CITY : 'city',	// string
			
			// Not currently used
			UID_SIGNATURE : 'UIDSignature',	// string
			SIGNATURE_TIMESTAMP : 'signatureTimeStamp',	// number
			LOGIN_PROVIDER : 'loginProvider', 	// string
			LOGIN_PROVIDER_UID : 'loginProviderUID', // string
			IS_SITE_USER : 'isSiteUser', 	// Boolean
			IS_TEMP_USER : 'isTempUser', 	// Boolean
			IS_CONNECTED : 'isConnected', 	// Boolean
			IDENTITIES : 'identities', 	// dictionary object
			THUMBNAIL_URL : 'thumbnailURL',
			AGE : 'age', // number
			ZIP : 'zip',	// string
			PROFILE_URL : 'profileURL',	// string
			LIKES : 'likes',	// string
			I_RANK : 'iRank', 	// number
			CAPABILITIES : 'capabiilites', // string
			LANGUAGES : 'languages',	// string
			ADDRESS : 'address', 	// string
			PHONES : 'phones',	// string
			EDUCATION : 'education',	// array of objects
			HONORS : 'honors',	// string
			PUBLICATIONS : 'publications', 	// array of objects
			PATIENTS : 'patents',	// array of objects
			CERTIFICATIONS : 'certifications',	// array of objects
			PROFESSIONAL_HEADLINE : 'professionalHeadline',	// string
			BIO : 'bio',	// string
			INDUSTRY : 'industry',	// string
			SPECIALTIES : 'specialties',	// string
			WORK : 'work',	// array of objects
			SKILLS : 'skills',	// array of objects
			RELIGION : 'religion',	// string
			POLITICAL_VIEW : 'politicalView',	// string
			INTERESTED_IN : 'interestedIn',	// string
			RELATIONSHIP_STATUS : 'relationshipStatus',	// string
			HOMETOWN : 'hometown',	// string
			FAVORITES : 'favorites',	// JSON object
			USERNAME : 'username',	// string
			LOCALE : 'locale',	// string
			VERIFIED : 'verified',	// Boolean
			TIMEZONE : 'timezone',	// string
			
			// Deprecated
			UID_SIG : 'UIDSig', // string. Use UIDSignature
			TIMESTAMP : 'timestamp', // string. Use signatureTimestamp
			IS_LOGGED_IN : 'isLoggedIn'	// Boolean.
		}, 
		
		AUTH_TOKEN : 'auth_token',

		COOKIE : {
			NAME : 'cookieName',
			VALUE : 'cookieValue',
			PATH : 'cookiePath',
			DOMAIN : 'cookieDomain'
		}
	},
	
	API_KEY : '2_7kdDan99DJTVE_z9QKYSno1AvTyz8h5bM9UiEfq_HaTfQgIeeCmRY7wvf11WJhcz',
	
	/**
	 * Which Gigya API to use?  'rest', or 'javascript'
	 * Currently, only the REST API is implemented for direct access, since the 
 	 * Javascript API relies heavily on cookies and local storage, which is not
	 * currently accessible from the DeviceDataWidget used to embed the Gigya UI.
	 */
 
	API_METHOD : 'rest', 
	
	/**
	 * Files (temporary) used to transfer information between the UI components (generated with DeviceDataWidget)
	 * and the main WebView
	 */
	FILE : {
		JSON : '/tmp/gigya.json',
		COOKIES : '/tmp/gigya.cookies',
	},
	
	ENUM : {
		// Mapping of the Facebook location to state/country
		LOCATION : {
			'Alabama' 					: { stateCode : 'AL', country : 'United States' },
			'Alaska'					: { stateCode : 'AK', country : 'United States' },
			'American Samoa'			: { stateCode : 'AS' },
			'Arizona'					: { stateCode : 'AZ', country : 'United States' },
			'Arkansas'					: { stateCode : 'AR', country : 'United States' },
			'California'				: { stateCode : 'CA', country : 'United States' },
			'Colorado'					: { stateCode : 'CO', country : 'United States' },
			'Connecticut'				: { stateCode : 'CT', country : 'United States' },
			'Delaware'					: { stateCode : 'DE', country : 'United States' },
			'Washington, DC'			: { stateCode : 'DC', country : 'United States' },
			'Florida'					: { stateCode : 'FL', country : 'United States' },
			'Georgia'					: { stateCode : 'GA', country : 'United States' },
			'Guam'						: { stateCode : 'GU' },
			'Hawaii'					: { stateCode : 'HI', country : 'United States' },
			'Idaho'						: { stateCode : 'ID', country : 'United States' },
			'Illinois'					: { stateCode : 'IL', country : 'United States' },
			'Indiana'					: { stateCode : 'IN', country : 'United States' },
			'Iowa'						: { stateCode : 'IA', country : 'United States' },
			'Kansas'					: { stateCode : 'KS', country : 'United States' },
			'Kentucky'					: { stateCode : 'KY', country : 'United States' },
			'Lousiana'					: { stateCode : 'LA', country : 'United States' },
			'Maine'						: { stateCode : 'ME', country : 'United States' },
			'Maryland'					: { stateCode : 'MD', country : 'United States' },
			'Marshall Islands'			: { stateCode : 'MH' },
			'Massachusetts'				: { stateCode : 'MA', country : 'United States' },
			'Michigan'					: { stateCode : 'MI', country : 'United States' },
			'Micronesia'				: { stateCode : 'FM' },
			'Minnesota'					: { stateCode : 'MN', country : 'United States' },
			'Mississippi'				: { stateCode : 'MS', country : 'United States' },
			'Missouri'					: { stateCode : 'MO', country : 'United States' },
			'Montana'					: { stateCode : 'MT', country : 'United States' },
			'Nebraska'					: { stateCode : 'NE', country : 'United States' },
			'Nevada'					: { stateCode : 'NV', country : 'United States' },
			'New Hampshire'				: { stateCode : 'NH', country : 'United States' },
			'New Jersey'				: { stateCode : 'NJ', country : 'United States' },
			'New Mexico'				: { stateCode : 'NM', country : 'United States' },
			'New York'					: { stateCode : 'NY', country : 'United States' },
			'North Carolina'			: { stateCode : 'NC', country : 'United States' },
			'North Dakota'				: { stateCode : 'ND', country : 'United States' },
			'Northern Mariana Islands' 	: { stateCode : 'MP' },
			'Ohio'						: { stateCode : 'OH', country : 'United States' },
			'Oklahoma'					: { stateCode : 'OK', country : 'United States' },
			'Oregon'					: { stateCode : 'OR', country : 'United States' },
			'Palau'						: { stateCode : 'PW' },
			'Pennsylvania'				: { stateCode : 'PA', country : 'United States' },
			'Puerto Rico'				: { stateCode : 'PR' },
			'Rhode Island'				: { stateCode : 'RI', country : 'United States' },
			'South Carolina'			: { stateCode : 'SC', country : 'United States' },
			'South Dakota'				: { stateCode : 'SD', country : 'United States' },
			'Tennessee'					: { stateCode : 'TN', country : 'United States' },
			'Texas'						: { stateCode : 'TX', country : 'United States' },
			'Utah'						: { stateCode : 'UT', country : 'United States' },
			'Vermont'					: { stateCode : 'VT', country : 'United States' },
			'Virginia'					: { stateCode : 'VA', country : 'United States' },
			'Washington'				: { stateCode : 'WA', country : 'United States' },
			'West Virginia'				: { stateCode : 'WV', country : 'United States' },
			'Wisconsin'					: { stateCode : 'WI', country : 'United States' },
			'Wyoming'					: { stateCode : 'WY', country : 'United States' },
			'Alberta'					: { stateCode : 'AB', country : 'Canada' },
			'British Columbia'			: { stateCode : 'BC', country : 'Canada' },
			'Manitoba'					: { stateCode : 'MB', country : 'Canada' },
			'New Brunswick'				: { stateCode : 'NB', country : 'Canada' },
			'Newfoundland and Labrador'	: { stateCode : 'NL', country : 'Canada' },
			'Nova Scotia'				: { stateCode : 'NS', country : 'Canada' },
			'Nunavut'					: { stateCode : 'NU', country : 'Canada' },
			'Northwest Territories'		: { stateCode : 'NT', country : 'Canada' },
			'Ontario'					: { stateCode : 'ON', country : 'Canada' },
			'Prince Edward Island'		: { stateCode : 'PE', country : 'Canada' },
			'Quebec'					: { stateCode : 'QC', country : 'Canada' },
			'Saskatchewan'				: { stateCode : 'SK', country : 'Canada' },
			'Yukon'						: { stateCode : 'YT', country : 'Canada' }
		}
	},

/**
 * Methods
 */
	/**
	 *  Get list of NP supported providers
	 */
	supportedProviders : function  gigyaObjSupportedProviders() {
		return this._toArray(this.PROVIDERS);
	},
	
	/**
	 * Initialize the global user variable to accommodate the information obtained from gigya
	 */
	_init : function gigyaObjInit() {
		if (typeof(window.user.gigya) == 'undefined') {
			window.user.gigya = {};
		}
		if (typeof(window.user.gigya.user) == 'undefined') {
			window.user.gigya.user = {};
		}
	}, 
	
	/**
	 * Convert single-level Javascript object to standard array, useful for $.inArray() context
	 */
	_toArray : function gigyaObjToArray(obj) {
		var newObj = obj;
		if ( !$.isArray(obj) ) {
			newObj = new Array();
			$.each(obj, function(key, value) {
				newObj.push(value);
			});
		}
		return newObj;
	},
	
	/**
	 * Is the current user connected to the specified provider?
	 * Note: If user is not logged in to Gigya, this will always return false.
	 */
	isConnected : function gigyaObjIsConnected(provider) {
		this._init();
		switch (typeof(window.user.gigya.user.providers)) {
		case 'object':
			// User is connected to more than one provider via Gigya. Verify the 
			// selected provider is in the list
			return ($.inArray(provider, user.gigya.user.providers) > -1);
		case 'string':
			// Only one provider is connected via Gigya
			return (provider == user.gigya.user.providers);
		default: 
			return false;
		}
	},
	
	/**
	 * Returns the current user's information (Gigya data stored locally)
	 * Note: see also: getUserLocation, if attempting to retrieve 
	 * FIELDS.USER.CITY, FIELDS.USER.STATE, or FIELDS.USER.COUNTRY
	 * @param	field	
	 * 				Required.	The FIELD to return
	 */
	getUserData : function gigyaObjGetUserData(field) {
		this._init();
		if ($.inArray(field, this._toArray(gigyaObj.FIELDS.USER)) > -1) {
			// Return individual user field
			if (typeof(window.user.gigya.user[field]) != 'undefined') {
				return window.user.gigya.user[field];
			}
				
		} else if ($.inArray(field, this._toArray(gigyaObj.FIELDS.COOKIE)) > -1) {
			if (typeof(window.user.gigya.cookie) != 'undefined' && typeof(window.user.gigya.cookie[field]) != 'undefined') {
				return window.user.gigya.cookie[field];
			}
			
		} else {
			switch (field) {
			case gigyaObj.FIELDS.USER:
				if (typeof(window.user.gigya.user) != 'undefined') {
					return window.user.gigya.user;
				}
				break;
			case gigyaObj.FIELDS.COOKIE:
				if (typeof(window.user.gigya.cookie) != 'undefined') {
					return window.user.gigya.cookie;
				} 
				break;
			default:
				if (typeof(window.user.gigya[field]) != 'undefined') {
					return window.user.gigya[field];
				}
			}
		} 
		return null;
	},
	
	/**
	 * Parse the user's location
	 * Facebook actually has "city, state" (if in the US) or "city, country"
	 * as the city, with state and country being null, so using getUserData(FIELDS.USER.CITY/STATE/COUNTRY)
	 * will likely not provide the information desired. This function attempts
	 * to determine the appropriate city, state and country from the data
	 * Facebook provides 
	 */
	getUserLocation : function gigyaObjGetUserLocation() {
		var location = {
			city : this.getUserData(this.FIELDS.USER.CITY),
			state : this.getUserData(this.FIELDS.USER.STATE),
			country : this.getUserData(this.FIELDS.USER.COUNTRY)
		};
		if (location.state == null || location.country == null) {
			// State or Country is not available, attempt to deduce from "City"
			if ( typeof ( location.city == 'undefined')) {
				// No information, so cannot provide any more detail.
				
			} else if ( typeof (this.ENUM.LOCATION[location.city]) != 'undefined') {
				// "City" matches a designated location; reset the city and load from the designated location
				delete location.city;
				$.each(this.ENUM.LOCATION[location.city], function(key, value) {
					location[key] = value;
				});
			} else {
				var test = location.city.split(/,\s*/);
				if (test.length > 1) {
					// City includes either a recognized state or a recognized country
					// Reset City to exclude the state or country 
					location.city = test[0]; 
					if (typeof (this.ENUM.LOCATION[test[1]]) != 'undefined') {
						// Retrieve the state/country from the recognized locations
						$.each(this.ENUM.LOCATION[test[1]], function(key, value) {
							location[key] = value;
						});
					} else {
						// Not recognized, just save the remainder to Country 
						location.country = test[1];
						for (var i=2; i<test.length; i++) {
							location.country += test[i];
						}
					}
				}
			}
		}
		return location;
	},
	
	/**
	 * Set the user's information (Gigya data stored locally)
	 * @param	response
	 * 				Optional. JSON containing the Gigya data. 
	 * 				If not provided, and FILE.JSON is available, the response 
	 * 				will be retrieved from the file.
	 * 			field
	 * 				Optional. If provided, will only update the specified field
	 */
	setUserData : function gigyaObjSetUserData(response, field) {
		this._init();
		if (!response && npfunctions.file_exists(this.FILE.JSON) == "1") {
			// Read "transfer file"
			if ($.fn.jquery >= "1.4.1") {
				var text = npfunctions.read_file(this.FILE.JSON);
				response = $.parseJSON(text);
			} else {
				var text = '[' + npfunctions.read_file(this.FILE.JSON) + ']';
				console.log(text);
				response = eval(text)[0];
			}
			writeLog('debug', 'gigyaObj.setUserData(): parsing contents of ' + this.FILE.JSON + ' - ' + JSON.stringify(response));
		}
		if (!response) {
			// Nothing to save
			return;
		}
		
		var userFields = this._toArray(this.FIELDS.USER);
		var cookieFields = this._toArray(this.FIELDS.COOKIE);
		if (typeof(field) == 'object') {
			// force object (name=value) to array of values
			field = this._toArray(field);
		}
		if (field && response[field]) {
			// save only specified field
			if ($.inArray(key, userFields) > -1) {
				window.user.gigya.user[field] = response[field];
			} else if ($.inArray(key, cookieFields) > -1) {
				window.user.gigya.cookie[field] = response[field];
			} else {
				window.user.gigya[field] = response[field];
			}
			window.user.gigya.user[field] = response[field];

		} else if ($.inArray(typeof(field), ['undefined', 'object']) < 0) {
			// specified (single) field is blank, null out current value 
			window.user.gigya.user[field] = null;
		
		} else {
			if (typeof(field) == 'undefined') {
				// Replace User info with all the fields of the new response
				this.reset(true);
			}
			$.each(response, function(key, value) {
				var cont = false;
				switch (typeof(field)) {
				case 'undefined':
					// save all fields
					cont = true;
					break;
				case 'string':
					// Only one field targeted, skip if not the same
					if (field == key)
						cont = true;
					break;
				case 'object':
					// Specific fields are targeted, skip if not in the list
					if ($.inArray(key, field) > -1) 
						cont = true;
					break;
				}
				if (cont) {
					if ($.inArray(key, userFields) > -1) {
						// User fields
						if (typeof(window.user.gigya.user) == 'undefined') {
							window.user.gigya.user = {};
						}
						window.user.gigya.user[key] = value;
					
					} else if ($.inArray(key, cookieFields) > -1) {
						// Cookie fields
						if (typeof(window.user.gigya.cookie) == 'undefined') {
							window.user.gigya.cookie = {};
						}
						window.user.gigya.cookie[key] = value;
					
					} else {
						window.user.gigya[key] = value;
					}
				}
			});
				
			if (!window.user.gigya.user[gigyaObj.FIELDS.USER.IS_SITE_UID]) {
				window.user.gigya[gigyaObj.FIELDS.GIGYA_ID] = window.user.gigya.user[gigyaObj.FIELDS.USER.UID];
			}
		}
	},
	
	/**
	 * Reset the user's information (Gigya data).  Typically used when the user logs out.
	 * @param	full	
	 * 				Boolean.
	 * 				false = delete temporary files created by Gigya interaction.
	 * 				true  = delete temporary files AND force resetting of local Gigya data.
	 */
	reset : function gigyaObjReset(full) {
		// Clean up temporary files created by Gigya interaction 
		$.each(this.FILE, function(key, value) {
			if (npfunctions.file_exists(value)) {
				npfunctions.remove_file(value);
			}
		});
		// Clear the data retrieved from Gigya
		if (full) {
			window.user.gigya = {};
			this._init();
		}
	},
	
	/**
	 * Sets the user's information (Gigya data) based on a successful response from Gigya.
	 * @param	response
	 * 				Required. JSON returned by Gigya API call
	 */
	updateUserFromResponse : function gigyaObjUpdateUserFromResponse(response) {
		writeLog('debug', 'gigyaObj.updateUserFromResponse(): ' + JSON.stringify(response));
		if (response.errorCode == 0) {
			gigyaObj.setUserData(response);
		}
	},
	
	/**
	 *  Generates JSON representing the Gigya response from a full URL query string
	 *  (i.e. http://s2.netpulse.ws/endGigya?provider=facebook&errorCode=0&UID=55&... returns
	 *  	{ 
	 *  		"provider" : "facebook", 
	 *  		"errorCode" : 0, 
	 *  		"UID" : "55" 
	 *  		... 
	 *  	}
	 */
	parseGigyaResponse : function gigyaObjParseGigyaResponse(url) {
		var loc = this.parseURL(url);

        //if ((!loc.hostname.match('socialize.gigya.com') && loc.hostname.match('gigya'))
		//		// Ignore gigya Javascript API calls but process any gigya callbacks (i.e. Cancel)
        //
		//		|| (loc.hostname.match(/netpulse\.ws/) && typeof(loc.params.status) != 'undefined'  && loc.params.status == 'done')
		//		// Process the results of the redirect
		//) {
        //writeLog('debug', 'DeviceDataWidget ---- loc.path: '+loc.path);
        if (loc.hostname.match(/netpulse.(ws|net)/i)) {
            if (loc.path.match('/s2/endGigya')) {
                if (typeof(loc.params.errorCode) != 'undefined' /*&& loc.params.errorCode == 'done'*/)  {
                    $.each(loc.params, function(index, value) {
                        // Convert strings "True"/"False" to boolean equivalents
                        switch (value.toLowerCase()) {
                        case 'true':
                            loc.params[index] = true;
                            break;
                        case 'false':
                            loc.params[index] = false;
                            break;
                        }

                        switch (index) {
                        case 'errorCode':
                            loc.params[index] = parseInt(value);
                        }
                    });
                    console.log("loc.params:" + loc.params);
                    return loc.params;
                }
            }
            else if (loc.path.match('/GS/GSLogin.aspx')) {
                return loc.params;
            }
        }
        writeLog('debug', 'DeviceDataWidget ---- parseGigyaResponse() returning null');
		return null;
	},
	
	/**
	 * Parses a URL into discrete components
	 */
	parseURL : function gigyaObjParseURL(url) {
	    var a =  document.createElement('a');
	    a.href = url;
	    return {
	        source: url,
	        protocol: a.protocol.replace(':',''),
	        host: a.host,
	        hostname: a.hostname,
	        port: a.port,
	        query: a.search,
	        params: (function gigyaObjParseURLParams(){
	            var ret = {},
	                seg = a.search.replace(/^\?/,'').split('&'),
	                len = seg.length, i = 0, s;
	            for (;i<len;i++) {
	                if (!seg[i]) { continue; }
	                s = seg[i].split('=');
	                ret[s[0]] = s[1];
	            }
	            return ret;
	        })(),
	        file: (a.pathname.match(/\/([^\/?#]+)$/i) || [,''])[1],
	        hash: a.hash.replace('#',''),
	        path: a.pathname.replace(/^([^\/])/,'/$1'),
	        relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || [,''])[1],
	        segments: a.pathname.replace(/^\//,'').split('/')
	    };
	},
	
//	// internal functions to manage cookies
//	_createCookie : function(name,value,days,path,domain) {
//		var expires = "";
//		if (days) {
//			var date = new Date();
//			date.setTime(date.getTime()+(days*24*60*60*1000));
//			expires = "; expires="+date.toGMTString();
//		}
//		if (path)
//			path = "; path=" + path;
//		else 
//			path = "";
//		if (domain)
//			domain = "; domain=" + domain;
//		else domain = "";
//		document.cookie = name+"="+value+expires+path+domain;
//	},
//
//	_readCookie : function(name) {
//		var nameEQ = name + "=";
//		var ca = document.cookie.split(';');
//		for(var i=0;i < ca.length;i++) {
//			var c = ca[i];
//			while (c.charAt(0)==' ') c = c.substring(1,c.length);
//			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
//		}
//		return null;
//	},
//
//	_eraseCookie : function(name) {
//		this._createCookie(name,"",-1);
//	},
//
	// internal functions for all API calls
	_execute : function gigyaObj_execute(method, params) {
		var apiMethod = this.API_METHOD;
		if (params.apiMethod) {
			apiMethod = params.apiMethod;
			delete params.apiMethod;
		}
		
		// Use Gigya REST API calls via Netpulse proxy
		if (apiMethod == 'rest') {
			this._callProxy(method, params);
		} else {
			this._callJs(method, params);
		}
	},

	/**
	 * Execute via Javascript API
	 */
	_callJs : function gigyaObj_callJs(method, params) {
		gigya.socialize[method](params);
	},
	
	/**
	 * Execute using REST API calls via Netpulse proxy
	 */
	_callProxy : function gigyaObj_callProxy(method, params) {
		writeLog('debug', "_callProxy: method=" + method + ", params=" + JSON.stringify(params));
		if (!params.format) {
			params.format = 'json';
		}
		var callback = params.callback ? params.callback : this._proxyCallback;
		var errorCallback = params.errorCallback ? params.errorCallback : null;
		var continueCallback = params.continueCallback ? params.continueCallback : null;
		var reqTimeout = 10000;
		var queryString = this._JsonToQueryString(params);
		var src = machineObj.getServerLocation() + "s2/gigyaProxy/" + method + '?' + queryString; 
		var format = 'xml';
		if (params.format) {
			format = params.format;
		}
		switch (format) {
		case 'xml':
			// Note: support for $.ajax() with xml results is limited in jQuery versions prior to 1.5,
			// generally resulting in parseerror
			// Since many of the Gigya REST API methods have deprecated the xml format, this should be rare.
			dirtyHarry(src, callback, errorCallback, continueCallback, reqTimeout);
			break;
		case 'json':
			writeLog('debug', src);
			$.ajax({
				  url: src,
				  dataType: 'json',
				  success: callback,
				  error: errorCallback,
				  complete: continueCallback,
				  timeout: reqTimeout
				});
			//$.getJSON(src, callback);
			break;
		}
	}, 
	
	/**
	 * Default callback for REST API calls via Netpulse proxy
	 */
	_proxyCallback : function gigyaObj_proxyCallback(data, textStatus, jqXHR) {
		console.log(data);
		console.log(textStatus);
		console.log(jqXHR);
	},
	
	/**
	 * Convert JSON to standard query string
	 */
	_JsonToQueryString : function gigyaObj_JsonToQueryString(json) {
		var queryString = [];
		
		// List of query parameters that need to be deferred to the end of the query string 
		var deferred = [
		    'callback',	// Often contains javascript code that is lengthy and can contain characters that confuse the proxy
		    'context'	// Can contain characters that confuse the proxy
		];
		var deferredQuery = [];
		
		if (typeof(json.cid) == 'undefined') {
			// No context id provided, so set the default to skin.viewName
			json.cid = g_mfgStyle + '.' + viewManager.activeObject.name;
		}
		$.each(json, function(key, value) {
			if ($.inArray(key, deferred) > -1) {
				deferredQuery.push(key + '=' + value);
			} else {
				queryString.push(key + '=' + value);
			}
		});
		$.each(deferredQuery, function(key, value) {
			queryString.push(value);
		});
		
		return queryString.join('&');
	},
	
	/**
	 * Convert Javascript API parameters to OAuth 2.0 variants
	 * Not currently used, due to limitations with Gigya Javascript API
	 */ 
	_oauth2 : function gigyaObj_oauth2(params) {
		var newParams = {
			client_id : this.API_KEY	
		};
		$.each(params, function(key, value) {
			switch(key) {
			case 'provider': 
				key = 'x_provider';
				break;
			case 'redirectURL':
				key = 'redirect_uri';
				break;
			}
			
			newParams[key] = value;
		});
		return newParams;
	},
	
	/**
	 * Returns a Gigya-compatible language code from the current language/locale settings
	 */
	_getLanguage : function gigyaObj_getLanguage() {
		var language = athleteObj.get_locale();
		
		// Convert NP language code to Gigya language code
		switch (language) {
		case 'zht':	// Traditional Chinese
			language = 'zh-tw'; // Chinese (Taiwan)
			break;
		case 'zhs': // Simplified Chinese
			language = 'zh-cn';	// Chinese (mainland China).  
			/* Other possible variants: 
			 * 	zh-hk	Chinese (Hong Kong)
			 * 	zh-tw	Chinese (Taiwan)
			 */
			break;
		// Languages not supported by Gigya
		case 'unsupported':
			language = 'en'; // Revert to english
			break;
		default:
			// Use the hyphenated version
			language = language.replace("_", "-");
		}
		return language;
	},
	
/**
 *  Accessors for Gigya methods that require UI
 */
	login : function gigyaObjLogin(params, container, callback) {
		var src = '';
//		if (this.API_METHOD == 'rest') {
//			// Convert parameters for OAuth 2.0
//			params = this._oauth2(params);
//			params.response_type = 'token';
//
//			var queryString = this._JsonToQueryString(params);
////			src = 'http://qa-s2.netpulse.ws/s2/gigyaProxy/login?x_provider=facebook&client_id=2_7kdDan99DJTVE_z9QKYSno1AvTyz8h5bM9UiEfq_HaTfQgIeeCmRY7wvf11WJhcz&redirect_uri=http%3A%2F%2Fqa-s2.netpulse.ws%2Fs2%2FgigyaLogin&response_type=code';		
//			src = machineObj.getServerLocation() + "s2/gigyaProxy/login?" + queryString; 
////			src = "http://" + machineObj.getServerDomain() + "/s2/gigyaProxy/login?" + queryString; 
//		
//		} else {
		params.skin = machineObj.getSkinName();
		params.lang = this._getLanguage();
		if (this.getUserData(this.FIELDS.COOKIE.NAME)) {
			params.cookie = encodeURIComponent(JSON.stringify(this.getUserData(this.FIELDS.COOKIE)));
		}
		var queryString = this._JsonToQueryString(params);
		src = machineObj.getServerLocation() + "s2/beginLogin?" + queryString;
// TODO: For development only
//			src = "http://qa-ec2.netpulse.ws/pantheon/tmp/s2/beginLogin.scala.html?" + queryString;
//		}
		
		var objectString = '<object id="auth_gigya" type="text/html" class="auth" url="' + src + '" lang="' + params.lang + '" visible="true" onurlchange="' + callback + '" />';
		return this._drawUI(objectString, container);
	}, 
	
	addConnection : function gigyaObjAddConnection(params, container, callback) {
		var src = '';
//		if (this.API_METHOD == 'rest') {
//			// Convert parameters for OAuth 2.0
//			params = this._oauth2(params);
//			params.response_type = 'token';
//
//			var queryString = this._JsonToQueryString(params);
//			src = machineObj.getServerLocation() + "s2/gigyaProxy/addConnection?" + queryString; 
////			src = "http://" + machineObj.getServerDomain() + "/s2/gigyaProxy/addConnection?" + queryString; 
//		
//		} else {
		if (!params.uid) {
			params.uid = this.getUserData(this.FIELDS.USER.UID);
		}
		params.skin = machineObj.getSkinName();
		params.lang = this._getLanguage();
		if (this.getUserData(this.FIELDS.COOKIE.NAME)) {
			params.cookie = encodeURIComponent(JSON.stringify(this.getUserData(this.FIELDS.COOKIE)));
		}
		var queryString = this._JsonToQueryString(params);
		src = machineObj.getServerLocation() + "s2/beginConnection?" + queryString; 
// TODO: For development only
//			src = "http://qa-ec2.netpulse.ws/pantheon/tmp/s2/beginConnection.scala.html?" + queryString;
//		}
		var objectString = '<object id="auth_gigya" type="text/html" class="auth" url="' + src + '" lang="' + params.lang + '" visible="true" onurlchange="' + callback + '" />';
		return this._drawUI(objectString, container);
	},
	
	/**
	 * Create the widgets for the 3rd-party forms and the associated keyboard
	 * Returns an object with JS references to both widgets 
	 */
	_drawUI : function gigyaObj_drawUI(objectString, container) {
		$auth_gigya = $(objectString);
		// Show page.
		container.append($auth_gigya);
		// Show keyboard
		$iKB = $('<div id="keyboard"><object id="iKB" type="keyboard" target="auth_gigya" style="visibility:show; display:block;" /></div>');
		container.append($iKB);
		$iKB = container.find('object#iKB');
		guiObj.testKeyboard();
		return { 
			auth_gigya : $auth_gigya,
			iKB : $iKB
		};
	}, 
		
/**
 *  Accessors for Gigya methods that do not require UI
 */
	getUserInfo : function gigyaObjGetUserInfo(params) {
		writeLog('debug', "getUserInfo: params=" + JSON.stringify(params));

		if (!params.uid)
			params.uid = this.getUserData(this.FIELDS.USER.UID);
		if (!params.callback)
			params.callback = this.updateUserFromResponse;
		this._execute('getUserInfo', params);
	}, 
	
	logout : function gigyaObjLogout(params) {
		if (typeof(params) == 'undefined') {
			params = {
			};
		}
		params.uid = this.getUserData(this.FIELDS.USER.UID);
		this._execute('logout', params);
	},
	
	notifyLogin : function gigyaObjNotifyLogin(params) {
		if (params.uid && !params.siteUID) {
			params.siteUID = params.uid;
		}
		if (!params.siteUID)
			params.siteUID = this.getUserData(this.FIELDS.USER.UID);
		if (!params.callback)
			params.callback = this._notifyLoginCallback;
		this._execute('notifyLogin', params);
	},
	
	/**
	 * Default callback for notifyLogin()
	 * @param response
	 */
	_notifyLoginCallback : function gigyaObj_notifyLoginCallback(response) {
		// Save cookie information
		gigyaObj.setUserData(response, gigyaObj.FIELDS.COOKIE);
	},
	
	notifyRegistration : function gigyaObjNotifyRegistration(params) {
		if (!params.uid)
			params.uid = encodeURIComponent(this.getUserData(this.FIELDS.GIGYA_UID));
		if (!params.siteUID)
			params.siteUID = this.getUserData(this.FIELDS.USER.UID);
		if (!params.format)
			params.format = 'json';
		if (!params.callback) {
			params.callback = function gigyaObjNotifyRegistrationParams(response) {
				//  Default callback for notifyRegistration() is to reload the userInfo
				if (response.errorCode == 0) {
					gigyaObj.getUserInfo({ uid : params.siteUID});
				}
				this._notifyRegistrationCallback;
			};
		}
		this._execute('notifyRegistration', params);
	}, 

	removeConnection : function gigyaObjRemoveConnection(params) {
		if (!params.uid) {
			if (this.getUserData(this.FIELDS.USER.IS_SITE_UID)) {
				params.uid = this.getUserData(this.FIELDS.USER.UID);
			} else {
				params.uid = encodeURIComponent(this.getUserData(this.FIELDS.GIGYA_ID));
			}	
		}
		this._execute('removeConnection', params);
	},
	
	setStatus : function gigyaObjSetStatus(params) {
		params.uid = this.getUserData(this.FIELDS.USER.UID);
		this._execute('setStatus', params);
	},
	
/**
 *  Demo mode convenience methods
 */
	addConnectionDemoUser : function gigyaObjAddConnectionDemoUser(provider) {
		this._init();
		if (!gigyaObj.isConnected(provider)) {
			if (typeof(window.user.gigya.user.providers) == 'undefined') {
				window.user.gigya.user.providers = new Array();
			}
			window.user.gigya.user.providers.push(provider);
		}
	},
	
	loginDemoUser : function gigyaObjLoginDemoUser(params, container) {
		var provider = params.provider;
		var objectString = '<object id="auth_gigya" type="text/html" class="auth" url="/netpulse/www/views/gigya/' + provider + '/demo.html" visible="true" onurlchange="viewManager.activeObject.onUrlChanged" />';
		return this._drawUI(objectString, container);
	},
	
	removeConnectionDemoUser : function gigyaObjRemoveConnectionDemoUser(provider) {
		this._init();
		var idx = window.user.gigya.user.providers.indexOf(provider);
		if (idx != -1) {
			window.user.gigya.user.providers.splice(idx, 1);
		}
	},
	
	// Override this in skin.js by defining:
	// gigyaObj.setDemoUser = function() { ... };
	setDemoUser : function gigyaObjSetDemoUser() {
		this._init();
		window.user.gigya.user = {
			providers : [gigyaObj.PROVIDERS.FACEBOOK],
			photoURL : 'file://' + DIR_ROOT + '/www/lifefitness/images/sara.png',
			firstName : 'Jamie',
			lastName : 'Marshall'
		};
	}
};

$(document).ready(function gigyaObjReady() {
	// If Gigya integration is disabled, activate the CSS rules to hide the UI elements associated with Gigya
	if (!gigyaObj.ENABLED) {
		$('body').addClass('gigyaDisabled');
	}	
});
