//
//  impressionsObj
//
function impressionsObj()
{
    this.impressions = new Array();
    this.file_location = DIR_ROOT + "/upload/";
}

impressionsObj.prototype.addImpression = function(impression) 
{
	if (impression instanceof mediaImpression) {
    	this.impressions.push(impression);
    	return true;
	}
	return false;
}

impressionsObj.prototype.writeImpressions = function() 
{
	var networkEnabled = false;
    switch(machineObj.getNetworkType().toLowerCase()) {
    	case 'wired':
    	case 'wireless':
    		networkEnabled = true;
    }

    if (!networkEnabled || machineObj.getMachineDemoNetwork() || !configObj.isInstalled() || this.impressions.length == 0) {
        return false;
    }
    
    var impressionsXML = '<impressions uuid="'+athleteObj.get_session_id()+'" machine_id="'+configObj.getMid()+'" exerciser_id="'+athleteObj.get_user_id()+'">'+'\n';
    for (var i=0; i<this.impressions.length; i++) {
    	impressionsXML += this.impressions[i].toXML();
    }
    impressionsXML += '</impressions>';

    var now = new Date();
    //  Filename is expected to be relative from machine.xml
    filename = this.file_location + "impressions_"+now.getTime()+".xml";

    //  Remove workout profile file if exists
    npfunctions.remove_file(filename);

    //  Write custom workout profile
    SetFileContents(filename, impressionsXML);
    
    return true;
}

/**
 * This class is designed to be the most generic type of impression that we would
 * want to record. 'Media' can refer to either a video or image -- the optional playTime
 * argument determines which. Subclasses can extend the behavior of mediaImpression.
 */
function mediaImpression(id, playTime) 
{
	this.id = id;
	this.playTime = null;
	this.tstamp = this.createTimestamp();
	
	// Make sure playTime is a number, or at least can be parsed as one.
	if (!isNaN(playTime)) {
		this.playTime = parseInt(playTime);	
	}
}

mediaImpression.prototype.toXML = function() 
{
	var xmlStr = '<content id="'+this.id+'" ';
	if (this.playTime != null) {
		xmlStr += 'playTime="'+this.playTime+'" ';
	}
	xmlStr += 'tstamp="'+this.tstamp+'" ';
	xmlStr += '/>' + '\n';
	
	return xmlStr;
}

mediaImpression.prototype.createTimestamp = function() 
{
	var now = new Date();
	
	var timestamp = now.getFullYear()+"-"+parseInt(now.getMonth() + 1)+"-"+now.getDate()+" "+now.getHours();
	timestamp += (String(now.getMinutes()).length == 1) ? ":0"+now.getMinutes() : ":"+now.getMinutes();
	timestamp += (String(now.getSeconds()).length == 1) ? ":0"+now.getSeconds() : ":"+now.getSeconds();

	return timestamp;
}

function adImpression(id, adunit, campaign, playTime, behavior) 
{
	this.id = id;
	this.adunit = adunit;
	this.campaign = campaign;
	this.playTime = null;
	this.behavior = null;
	this.tstamp = this.createTimestamp();
	
	if (!isNaN(playTime)) {
		this.playTime = parseInt(playTime);	
	}
	if (typeof(behavior) == "string") {
		this.behavior = behavior;
	}
}
adImpression.prototype = new mediaImpression;

adImpression.prototype.toXML = function() 
{
	var xmlStr = '<content id="'+this.id+'" adunit="'+this.adunit+'" campaign="'+this.campaign+'" ';
	if (this.playTime != null) {
		xmlStr += 'playTime="'+this.playTime+'" ';
	} 
	if (this.behavior != null) {
		xmlStr += 'behavior="'+this.behavior+'" ';
	}
	xmlStr += 'tstamp="'+this.tstamp+'" ';
	xmlStr += '/>' + '\n';
	
	return xmlStr;
}

