/*=====================================================================
    Error Logging Script (CORE) | /js/popError.js
=====================================================================*/

// Do/don't show popError messages.
window.bDisplayException = eval(DisplayException());

var popError = function PopError(e) {
    // arguments.callee.caller will be null when called from C++
    var caller = ((arguments.callee.caller && arguments.callee.caller.name) ? " in " + arguments.callee.caller.name.toString() + "() - " : " - ");
    var msg = ((e.sourceURL) ? ((e.name) ? e.name : "Error") + " in " + e.sourceURL + " on line " + e.line + caller + e.message : e);

    // We don't want the end user to see JavaScript alert messages.
    if (window.bDisplayException) {
        alert(msg);
    }

    writeLog("info", "Javascript Error --> " + msg);

    if (console && console.log) {
        console.log(msg);
    }
};

// Use writeLog to print currently running function to error.log.
var writeStatus = function WriteStatus(view) {
    var timeStamp = Math.round((new Date).getTime() / 1000),
        viewName = (view.name ? view.name : view),
        msg = "@" + arguments.callee.caller.name + ( viewName ? " in " + viewName : "") + " at " + timeStamp;

    writeLog("debug", msg);

    if (console && console.log) {
        console.log(msg);
    }
};

/* Log JS properties and values to console */
function readObject(obj) {
    var propsArray = [], props = null;
    for (props in obj) {
        propsArray.push(props + ':' + obj[props]);
    }
    console.log(propsArray.join("\n\t"));
}
