//
//  Netpulse postmaster general.
//

// TODO - pull this from machine.xml (or other such) 1:info, 2:debug, 3:verbose
postmasterLogLevel = 3;

function postmasterGeneral()
{
    this.logLevel = postmasterLogLevel;
    this.lvlStrs = ["error", "info", "debug", "verbose"];

    this.$container = $("#postmaster");
    this.$innerContainer = $("#postmaster .container");
    this.$slideButton = this.$innerContainer.find("#slideButton");
    this.$msgList = this.$innerContainer.find("ul");

    this.init();
}

postmasterGeneral.prototype.init = function()
{
    var me = this;

    this.$container.show();
    this.attachEvents();
}

postmasterGeneral.prototype.attachEvents = function()
{
    var me = this;
    me.$slideButton.bind("click.postmaster", function() { me.toggleSlide(); });
}

postmasterGeneral.prototype.toggleSlide = function() { this.$container.toggleClass("mini"); }

postmasterGeneral.prototype.postMessage = function(label, msg, lvl)
{
    var me = this;

    if(!me.lvlStrs[lvl])
        return;

    writeLog(me.lvlStrs[lvl], msg);

    if(lvl > me.logLevel)
        return;

    var html = "<li class='"+me.lvlStrs[lvl]+"'><span>"+label+":</span>&nbsp;&nbsp;"+msg+"</li>";
    me.$msgList.append(html);

    var list = document.getElementById("messageList");

    var needsToScroll = (list.scrollHeight - $(list).height() > list.scrollTop);

    if(needsToScroll)
        me.$msgList.animate({scrollTop: (list.scrollHeight - $(list).height())+"px"}, 400);
}



