countryConf = {

    
	/*
	 * Returns whether the installer should display the dialog to select/save 
	 * the default country in the local.xml.  By default, this is disabled,
	 * and should be overridden at the skin-specific level.
	 * 
	 * Parameter:
	 * 		stage	string	Example values:
	 * 						install (n5i/add-on installer)
	 * 						attract (n5i/lifefitness attract screen)
	 */
	'isEnabled' : function(stage) {
		var enabled = false;
		return enabled;
	},

    /*
     * Returns the number of enabled countries
     */
    'countEnabledCountries' : function() {
        // If it's in the list, it's enabled.
        return countryObj.getListSize();
    },
    /*
	 * Determines the Installer dialog default width.  If not using the default
	 * widths for the country button/li, this should be overridden at the skin
	 * level. 
	 */
	'dialogMinWidth' : function(countEnabled) {
		if(typeof(countEnabled) != 'number') {
			countEnabled = this.countEnabledCountries();
		}
		var width = 694;	// 3 columns
		if (countEnabled >15) 
			width = 914;	// 4 columns
		return width;
	},
	
	/*
	 * Display the dialog box to select the default language.
	 */
	'show' : function() {
		if ($("#countryDialog").exists())
			$("#countryDialog").remove();
		
		$("body").append('<div id="countryDialog"></div>');
		var html = '<ul id="country_selection">';
		var currentLocale =  machineObj.getCountryCode();
		
		var countEnabled = 0;
		$.each(this.countries, function(index, value) {
            html += '<li><button id="' + index + '" value="' + index + (index == currentLocale ? '" class="selected' : "") + '"><span>' + value.name + '</span></button></li>';
			countEnabled++;
		});
		html += '</ul>';
		var me = this;
		var okTransString = ((IDS_LANGUAGE.installCore['ok']) ? IDS_LANGUAGE.installCore['ok'] : "ok");
		var titleTransString = IDS_LANGUAGE.install['selectDefaultCountry'];
		$("#countryDialog").html(html)
			.dialog({
				'buttons' : [{
					text: okTransString, 
					click: function() { $(this).dialog("close"); }
				}],
				'dialogClass' : 'country',
				'modal' : true,
				'position' : ['center', 'center'],
				'title' : titleTransString,
                'minWidth' : this.dialogMinWidth(countEnabled),
                'width' : '976',
                'height' : '700'
			});

		$("ul#country_selection button").live("mousedown." + me.name, function(e) {
			me.select(e);
		});
	},
	
	/*
	 * Save the selected coutry as default in the local.xml
	 */
	'select' : function(e) {
		var target;
		var _this = this;
		if (e.target.nodeName == "BUTTON") {
			target = e.target;
		} else if (e.target.parentElement.nodeName == "BUTTON") {
			target = e.target.parentElement;
		}
		if (target) {
			$("ul#country_selection button").removeClass("selected");
			$(target).addClass("selected");
            machineObj.setLocationCountry(target.id);
		}
	},
	
	'countries' : evalJSON(decodeUTF8(countryObj.getCountryListJSON()))
};
