
$(document).ready(function() {

    bindHTMLElements();
    attachEvents();
    g_channelList = new Array();
    g_currentChannel = 0;
    
    ICON_DIR = DIR_ROOT + '/www/images/channelIcons';
    g_availableIcons = genIconList();

});

function bindHTMLElements()
{
    $advancedSetupBtn = $("#advancedChannelSetup");
    $editTitleBtn = $("#editTitle");
    $carouselBack = $("#iconCarouselBack");
    $carouselNext = $("#iconCarouselNext");
    $iconCarouselContainer = $("#iconCarousel");
    $iconCarousel = $("#iconCarousel ul");
    $popupKeyboard = $("#keyboardContainer");
    $popupKeybordInput = $("#keyboardContainer input");
    $keyboardCancelBtn = $("#keyboardContainer #cancelChanges");
    $keyboardSaveBtn = $("#keyboardContainer #saveTitle");

    $cancelBtn = $("#configureChannelsContainer #cancelButton");
    $saveBtn = $("#configureChannelsContainer #saveButton");

    $channelUpBtn = $("#channelUp");
    $channelDnBtn = $("#channelDown");
}

function attachEvents()
{
    $advancedSetupBtn.bind("click", function() { showChannelSetupPage(); });


    $carouselBack.bind("click", function() { scrollIconsBack(); });
    $carouselNext.bind("click", function() { scrollIconsNext(); });
    $iconCarousel.find("li").bind("click", function() { iconChosen($(this).attr("class")); });


    $popupKeyboard.bind("mousedown", function(e) { keyboardClicked(e); });
    $editTitleBtn.bind("mousedown", function() { showChannelTitleKeyboard(); });
    $("#editPosition").bind("mousedown", function() { showChannelPositionKeyboard('save'); });
    $("#editIcon").bind("click", function() {
    	/* TODO */
    	if ($('#iconDialog').exists())
    		$('#iconDialog').remove();
    	
    	$('body').append('<div id="iconDialog"></div>');
    	
    	var current = $('#channelIcon').attr('style');
    	var html = '<ul id="icon_selection">';
    			
    	$(g_availableIcons).each(function(index, value) {
    		var iconClass = [];
    		$(g_channelList).each(function(index, channelIcon) {
    			if (channelIcon.icon && value == channelIcon.icon) {
    				iconClass.push('disabled');
    			}
    		});
    		if (current.indexOf(value) >= 0) {
    			var idx = iconClass.indexOf('disabled');
    			if (idx >= 0) {
    				iconClass.splice(idx, 1);
    			}
    			iconClass.push('selected');
    		}
    		html += '<li><button ' + (iconClass.length ? ' class="' + iconClass.join(' ') +'"': '') + ' value="' + value + '" style="background-image:url(' + ICON_DIR + '/' + value +');"></button></li>';
    	});
    	
    	html += '</ul>';
    	
    	var me = this;
    	minimizeTVPlayer();
    	$('#iconDialog').html(html).dialog({
			'buttons' : [{
				text: IDS_LANGUAGE.installCore['ok'], 
				click: function() { $(this).dialog("close"); }
			}],
    		'dialogClass' : 'icon',
    		'draggable' : false,
    		'height' : 668,
    		'maxHeight' : 668,
    		'modal' : true,
    		'position' : [500], // avoid overlap with the TV output container
    		'title' : IDS_LANGUAGE.install['selectChannelIcon'],
    		'width' : 700 - 13 /* default scrollbar width */ + 60 /* custom scrollbar width in n5iinstall.css */,
    		
    		'open' : function(event, ui) {
    	    	$('ul#icon_selection button').bind('mousedown.' + me.name, function(e) {

    	    		if (!$(e.target).hasClass('disabled')) {
    	    			var prev = $('ul#icon_selection button.selected');
    	    			if (prev.length == 1 && prev[0] == e.target) {
    	    				// Toggle (clear) current selection
    	    				$(e.target).removeClass('selected');
    	    				iconChosen('');
    	    			} else {
    	    				prev.removeClass('selected');
    	        			iconChosen($(e.target).attr('value'));
    	        			$(e.target).addClass('selected');
    	    			}
    	    		}
    	    	});
    		},
    		'close' : function(event, ui) { 
				// Let jQuery finish closing the dialog box first
				setTimeout(function() { maximizeTVPlayer(); }, 20); 
			}
    	});
    	
    });

    $("#addNewChannel").bind("mousedown", function() { showChannelPositionKeyboard('add'); });
    $keyboardCancelBtn.bind("mousedown", function() { hideChannelTitleKeyboard(); });

    $cancelBtn.bind("mousedown", function() { hideChannelSetupPage(); });
    $saveBtn.bind("mousedown", function() { saveSetup(); hideChannelSetupPage(); });

    $channelDnBtn.bind("mousedown."+this.name, function() { tvChannelUiDn(); });
    $channelUpBtn.bind("mousedown."+this.name, function() { tvChannelUiUp(); });

    $("#channelEnabledToggle").bind("mousedown", function() { toggleDisableCurrentChannel(); });
    $("#addChannel").bind("mousedown", function() { showAddChannel(); });

    $("#numpadContainer").bind("mousedown", function(e) { numpadClicked(e); });
    $("#numpadContainer #cancelNewChannel").bind("mousedown", function(e) { hideAddChannel(); });
    $("#numpadContainer #saveNewChannel").bind("mousedown", function(e) { hideAddChannel(); saveNewChannel(); });

    $("#cancelScanButton").bind("mousedown", function() { cancelChannelScan(); });

    changeChannelTimer = null;
}

function tvChannelUiDn()
{
    //  Go around in a circle
    g_currentChannel = (g_currentChannel > 0) ? parseInt(g_currentChannel-1) : parseInt(g_channelList.length - 1);

    //  Update the display
    updateChannelUI(g_currentChannel);

    // Cancel the current timer
    clearTimeout(changeChannelTimer);

    //  Start new timer
    changeChannelTimer = setTimeout(function() { goToChannel(g_currentChannel); }, 500);
}

function tvChannelUiUp()
{
    //  Go around in a circle
    g_currentChannel = (g_currentChannel < parseInt(g_channelList.length - 1)) ? parseInt(g_currentChannel)+1 : 0;

    //  Update the display
    updateChannelUI(g_currentChannel);

    // Cancel the current timer
    clearTimeout(changeChannelTimer);

    //  Start new timer
    changeChannelTimer = setTimeout(function() { goToChannel(g_currentChannel); }, 500);
}

function updateChannelUI(channel)
{
    $("#channelInfoTitle span").html(g_channelList[channel].channel);
    $("#channelPosition").val(g_channelList[channel].position);
    var image = 'none';
    if (g_channelList[channel].icon) {
    	image = g_channelList[channel].icon;
    }
    $("#channelIcon").attr('style', 'background-image:url(' + ICON_DIR + '/' + image + ');');

    if(!g_channelList[g_currentChannel].name)
    {
        var fontSize = (g_channelList[channel].channel.length > 3) ? "16" : "32";
        $("#channelIndicator").empty().css("font-size",fontSize+"px").html(g_channelList[g_currentChannel].channel);   
        $("#channelTitle").val(g_channelList[g_currentChannel].channel);
    }
    else
    {
        var fontSize = (g_channelList[channel].name.length > 3) ? "16" : "32";
        $("#channelIndicator").empty().css("font-size",fontSize+"px").html(g_channelList[g_currentChannel].name);
        $("#channelTitle").val(g_channelList[g_currentChannel].name);
    }

    if(g_channelList[g_currentChannel].enabled)
        $("#channelEnabledToggle").removeClass();
    else
        $("#channelEnabledToggle").addClass("disabled");
}

function setUpdateTimer()
{
    clearTimeout(updateChannelTimer);
    updateChannelTimer = setTimeout(function() { clearTimeout(updateChannelTimer); goToChannel(currentChannelIdx); }, 500);
}

function showChannelSetupPage()
{
    $('#watchTvHolder').css("visibility","hidden");
    $("#configureChannelsContainer").removeClass("hidden");
    $("#editChannelsVideoPlayerObject").css("visibility","visible");

    setUpChannels();
}
function hideChannelSetupPage()
{
    $("#configureChannelsContainer").addClass("hidden");
    $("#editChannelsVideoPlayerObject").css("visibility","hidden");

    setTimeout(function() { $('#watchTvHolder').css("visibility","visible"); }, 500);
}

function setUpChannels() {
	g_channelList = [];
	try {
		$("#showAdvancedChannelSetup").removeClass("disabled");
		// $("#scanComplete #uploadConfiguration").removeClass("hidden");
		$("#scanComplete #addNewChannel").removeClass().addClass("hidden");
		g_channelList = constructChannelList();
		goToChannel(0);
	} catch(e) {
		g_currentChannel = 0;
		// Make sure we set the channel title in the UI to an empty string and disable the
		// Advance Channel Setup button, since no channels were found
		$("#channelIndicator").html("");
		hideChannelSetupPage();
		$("#showAdvancedChannelSetup").addClass("disabled");
		g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["noChannelsYo"]);
	}
}

function goToChannel(channel)
{
    g_currentChannel = parseInt(channel);
    setChannel(String(g_channelList[channel].originalPosition));

    $("#channelInfoTitle span").html(g_channelList[channel].channel);

    $("#channelPosition").val(g_channelList[channel].position);

    if(!g_channelList[g_currentChannel].name)
    {
        var fontSize = (g_channelList[channel].channel.length > 3) ? "16" : "32";
        $("#channelIndicator").empty().css("font-size",fontSize+"px").html(g_channelList[g_currentChannel].channel);   
        $("#channelTitle").val(g_channelList[g_currentChannel].channel);
    }
    else
    {
        var fontSize = (g_channelList[channel].name.length > 3) ? "16" : "32";
        $("#channelIndicator").empty().css("font-size",fontSize+"px").html(g_channelList[g_currentChannel].name);
        $("#channelTitle").val(g_channelList[g_currentChannel].name);
    }

    var image = 'none';
    if (g_channelList[channel].icon) {
    	image = g_channelList[channel].icon;
    }
    $("#channelIcon").attr('style', 'background-image:url(' + ICON_DIR + '/' + image + ');');

    if(g_channelList[g_currentChannel].enabled)
        $("#channelEnabledToggle").removeClass();
    else
        $("#channelEnabledToggle").addClass("disabled");
}

function channelUp()
{
    var newChannel = (g_currentChannel < g_channelList.length - 1) ? g_currentChannel+1 : 0;
    goToChannel(newChannel);
}
function channelDn()
{
    var newChannel = (g_currentChannel > 0) ? g_currentChannel-1 : g_channelList.length - 1;
    goToChannel(newChannel);
}

//  Flip enabled/disabled state for this channel
function toggleDisableCurrentChannel()
{
    g_channelList[g_currentChannel].enabled = !g_channelList[g_currentChannel].enabled;

    if(g_channelList[g_currentChannel].enabled)
        $("#channelEnabledToggle").removeClass();
    else
        $("#channelEnabledToggle").addClass("disabled");
}

function showAddChannel()
{
    $("#numpadInput").val("");
    $("#editChannelsVideoPlayerObject").css("visibility","hidden");
    $("#numpadContainer").show();
}
function hideAddChannel()
{ 
    $("#numpadContainer").hide();
    $("#editChannelsVideoPlayerObject").css("visibility","visible");
}

function saveNewChannel()
{
    var newChannelNumber = $("#numpadInput").val();
    if(newChannelNumber == "")
    {
        g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["channelNumber"]);
        return;
    }

    g_channelList.push({
        number    : newChannelNumber,
        name      : newChannelNumber,
        icon : "",
        position  : g_channelList.length,
        originalPosition : newOrigPosition
    });

    //  Resort channels to make sure that the new one is in order
    g_channelList.sort(sortByChannelNumber);

    //  Go to the added channel
    var channelIndex = -1;
    for(var i=0;i<g_channelList.length;i++)
        if(g_channelList[i].number == newChannelNumber)
            channelIndex = i;

    if(channelIndex != -1)
        goToChannel(channelIndex);
}

function numpadClicked(e)
{
    if(e.target.nodeName.toLowerCase() != "li")
        return;

    var $target = $(e.target);
    var currentValue = $("#numpadInput").val();

    if($target.is(".spacer"))
        return;

    else if($target.is(".bkspc"))
    {
        if(currentValue.length > 0)
            $("#numpadInput").val(currentValue.substr(0, (currentValue.length-1)));

        return;
    }

    var newChar = $target.html();
    $("#numpadInput").val(currentValue + newChar);
}

function showChannelTitleKeyboard()
{
    //  Grab current value
    $("#keyboardInput").val(g_channelList[g_currentChannel].name);
    $("#editChannelsVideoPlayerObject").css("visibility","hidden");

    //  Add title change functionality
    $keyboardSaveBtn.unbind("mousedown").bind("mousedown", function() { if(checkChannelTitleLength()) { saveTitleChange(); hideChannelTitleKeyboard(); } });

    //  Show all keys for title
    $("#keyboardContainer").removeClass();

    $("#tvContainer").removeClass().addClass("offscreen");
    $popupKeyboard.show();
}
function showChannelPositionKeyboard(operation)
{
    //  Grab current value
    $("#keyboardInput").val(g_channelList[g_currentChannel].position);
    $("#editChannelsVideoPlayerObject").css("visibility","hidden");

    //  Add position change functionality
    if(operation == 'save')
        $keyboardSaveBtn.unbind("mousedown").bind("mousedown", function() { savePositionChange(); hideChannelTitleKeyboard(); });
    if(operation == 'add')
        $keyboardSaveBtn.unbind("mousedown").bind("mousedown", function() { addThisChannel(); hideChannelTitleKeyboard(); });
    
    //  Only show number keys for position
    $("#keyboardContainer").removeClass().addClass("position");

    $("#tvContainer").removeClass().addClass("offscreen");
    $popupKeyboard.show();
}
function hideChannelTitleKeyboard()
{
    $("#tvContainer").removeClass();
    $popupKeyboard.hide();
    $("#editChannelsVideoPlayerObject").css("visibility","visible");
}

function checkChannelTitleLength()
{
    var val = $("#keyboardInput").val();

    if(val.length <= 7)
    {
        for(var i=0;i<g_channelList.length;i++)
        {
            if(i == g_currentChannel)
                continue;

            //  Check if name OR channel value match the user-entered value
            if(
                (String(g_channelList[i].name.toUpperCase()) == String(val.toUpperCase())) ||
                (String(g_channelList[i].channel.toUpperCase()) == String(val.toUpperCase()))
            )
            {
                g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["titleInUse"] + g_channelList[i].channel);
                return false;
            }
        }
        return true;
    }

    g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["titleLength"]);
    return false;
}

function saveTitleChange()
{
    g_channelList[g_currentChannel].name = $("#keyboardInput").val();
    $("#channelTitle").val(g_channelList[g_currentChannel].name);
    $("#channelIndicator").empty().html(g_channelList[g_currentChannel].name);
    
    if(g_channelList[g_currentChannel].name.length > 3){
        $('#channelIndicator').css('font-size',16);
    }
    
    else{
        $('#channelIndicator').css('font-size',32);
    }
    
}
function savePositionChange()
{
    var val = $("#keyboardInput").val();

    //  If blank or unchanged, do nothing
    if(val == "" || val == $("#channelPosition").val())
        return;

    //  Trim number bug #3488
    val = trimNumber(val);

    //  Go to chosen index and increment channel at that value and all following channels by one position bug #3500
    for(var i=0;i<g_channelList.length;i++)
    {
        if(i < parseInt(val))
            continue;

        g_channelList[i].position = String(parseInt(g_channelList[i].position) + 1);
    }

    //  Save new position and copy to position field
    g_channelList[g_currentChannel].position = val;
    $("#channelPosition").val(g_channelList[g_currentChannel].position);
}

function addThisChannel() {
    var val = trimNumber($("#keyboardInput").val());

    if (val == "" || val == g_channelList[g_currentChannel].channel)
        return;

    // Check if channel already exists in current list.  If so, user
    // should manually update existing instead of adding new
    $.each(g_channelList, function(index, obj) {
    	if (obj.channel == val) {
    		g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["channelExists"]);
    		return;
    	}
    });
    if(parseInt(val) <= 125 && parseInt(val) >= 0) {
        var newOrigPosition = String(parseInt(addAnalogChannel(val + ":" + val)) - 1);
	// Before adding a new channel, save the current configuration.
        saveSetup();
        addChannelsToXML(val);
        setUpChannels();
        sortInNewChannel(parseInt(val));
    // After adding a new channel, save the configuration.
        saveSetup();
    } else
        g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["outOfRange"]);
}

function sortInNewChannel(val)
{
    for(var i=0,newPosition=0;i<g_channelList.length;i++)
    {
        var channelNumberInt = parseInt(g_channelList[i].channel);

        //  Skip digital channels
        if(!(channelNumberInt >= 0))
            continue;

        if(channelNumberInt > val)
        {
            newPosition = String(i - 1);
            break;
        }
    }

    g_channelList[g_channelList.length - 1].position = newPosition;
    g_channelList.sort(sortByChannelPosition);
    for(var i=0;i<g_channelList.length;i++)
        if(g_channelList[i].channel == val)
        {
            goToChannel(i);
            return;
        }
}

function keyboardClicked(e)
{
    if(e.target.nodeName.toLowerCase() != "li")
        return;

    var $target = $(e.target);
    var currentTitle = $popupKeybordInput.val();

    if($target.is(".shift"))
    {
        $popupKeyboard.toggleClass("caps");
        return;
    }
    else if($target.is(".bkspc"))
    {
        if(currentTitle.length > 0)
            $popupKeybordInput.val(currentTitle.substr(0, (currentTitle.length-1)));

        return;
    }

    var newChar = ($target.is(".space")) ? " " : ($popupKeyboard.is(".caps")) ? $target.html().toUpperCase() : $target.html();
    $popupKeybordInput.val(currentTitle + newChar);

    $popupKeyboard.removeClass("caps");
}

function iconChosen(icon)
{
    g_channelList[g_currentChannel].icon = icon;
    $("#channelIcon").attr('style', 'background-image:url(' + ICON_DIR + '/' + icon + ');');
//    $("#selectedIcon").removeClass().addClass(icon);
    // After adding a new icon, save the configuration.
    saveSetup();
}


function sortByChannelPosition(a, b) { return (( parseInt(a.position) < parseInt(b.position)) ? -1 : ((parseInt(a.position) > parseInt(b.position)) ? 1 : 0)); }

//
//  Update tv.conf to have icon pairings
//
function saveSetup()
{
    if(g_channelList.length==0)
    	g_channelList = constructChannelList();

	if(g_channelList.length>0){
		var filename = DIR_ROOT + "/data/tv_conf.xml";

		var oldFileStr = read_file(filename);

		var startIndex = oldFileStr.search("<tvconf>");

		if(startIndex == -1)
		    return;

		var startStr = oldFileStr.substr(0,startIndex);
		var oldFileStr = oldFileStr.substr(startIndex);

		//  Reconstruct xml beginning with <DOCTYPE> and <tvconf>
		var newStr = startStr+"<tvconf>";

		//  Clone current <signal> tag
		var signalNode = (new DOMParser()).parseFromString(oldFileStr, 'text/xml').getElementsByTagName("signal")[0].cloneNode(true);
		newStr += "\n"+(new XMLSerializer()).serializeToString(signalNode);

		//  Start channel list
		newStr += "\n<channels>";
		
		g_channelList = g_channelList.sort(sortByChannelPosition);

		//  Write pairings
		for(var i=0;i<g_channelList.length;i++)
		{
		    var enabled = (g_channelList[i].enabled) ? "true" : "false";

			// Need to wrap attribute values in double quotes in case the channel name includes a single quote.
			// If the channel name has double quotes, just remove them. This will avoid xml parsing errors
		    newStr += "\n";
		    newStr += '<channel number="' + g_channelList[i].channel.replace(/"/g, '') + '" ' +
					           'name="' + g_channelList[i].name.replace(/"/g, '') + '" ' +
					           'icon="' + g_channelList[i].icon+ '" ' +
					           'position="' + g_channelList[i].position + '" ' +
					           'enabled="' + String(enabled) + '" ' +
					  '/>';
		}

		//  End xml
		newStr += "\n</channels>\n</tvconf>";

		//  Remove old tv_conf file
		npfunctions.remove_file(filename);

		//  Write new tv_conf file
		SetFileContents(filename, newStr);
	}

	else
	   writeLog("info", "g_channelList.length=0, we dont want to remove contents from tv_conf.xml when g_cha.. is empty.");
}

//
//  Cut off leading zeros
//
function trimNumber(s)
{
    while(s.substr(0,1) == '0' && s.length > 1)
        s = s.substring(1);

    return s;
}

function addChannelsToXML(chan) {
    try {
		var filename = DIR_ROOT + "/etc/stationlist.xml";

		var newStr = '<?xml version="1.0"?>\n';
		newStr += '<!DOCTYPE stationlist PUBLIC "-//tvtime//DTD stationlist 1.0//EN" "http://tvtime.sourceforge.net/DTD/stationlist1.dtd">\n';
		newStr += '<stationlist xmlns="http://tvtime.sourceforge.net/DTD/">\n';

		var oldFileStr = read_file(filename);
		var parser = new DOMParser();
		var oldFileDOM = parser.parseFromString(String(oldFileStr), 'text/xml');

		// Release parser from memory
		parser = null;

		var signalNode = oldFileDOM.getElementsByTagName("list")[0];

		newStr += '\t<list norm="'+signalNode.getAttribute('norm')+'" frequencies="'+signalNode.getAttribute('frequencies')+'" audio="'+signalNode.getAttribute('audio')+'">\n';

		signalNode = oldFileDOM.getElementsByTagName("station");

		// Release old DOM from memory
		oldFileDOM = null;

		for (var i = 0; i < signalNode.length; i++){
		    if (parseInt(signalNode[i].getAttribute('channel')) == parseInt(chan)) {
		        newStr += '\t\t<station name="'+signalNode[i].getAttribute('name')+'" active="1" position="'+signalNode[i].getAttribute('position')+'" band="'+signalNode[i].getAttribute('band')+'" channel="'+signalNode[i].getAttribute('channel')+'" finetune="'+signalNode[i].getAttribute('finetune')+'" audio="'+signalNode[i].getAttribute('audio')+'" norm="'+signalNode[i].getAttribute('norm')+'"/>\n';       
		    } else {
		        newStr += '\t\t<station name="'+signalNode[i].getAttribute('name')+'" active="'+signalNode[i].getAttribute('active')+'" position="'+signalNode[i].getAttribute('position')+'" band="'+signalNode[i].getAttribute('band')+'" channel="'+signalNode[i].getAttribute('channel')+'" finetune="'+signalNode[i].getAttribute('finetune')+'" audio="'+signalNode[i].getAttribute('audio')+'" norm="'+signalNode[i].getAttribute('norm')+'"/>\n';
		    }
		}

		newStr += '\t</list>\n</stationlist>\n';

		//  Remove old stationlist file
		npfunctions.remove_file(filename);

		//  Write new stationlist file
		SetFileContents(filename, newStr);

    } catch(e) {
    	//Commented out until we can understand the scope of what errors might be provided and how to internationalize them
    	//g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["addingError"] + e);
    	g_UI.showAlert(IDS_LANGUAGE.channelInstaller.notify["addingError"]);
    }
}

//
//  When the user scans channels, reset all channel pairings
//
function resetChannelPairings()
{
    var filename = DIR_ROOT + "/data/tv_conf.xml";

    var oldFileStr = read_file(filename);

    var startIndex = oldFileStr.search("<tvconf>");

    if(startIndex == -1)
        return;

    var startStr = oldFileStr.substr(0,startIndex);
    var oldFileStr = oldFileStr.substr(startIndex);

    //  Reconstruct xml beginning with <DOCTYPE> and <tvconf>
    var newStr = startStr+"<tvconf>";

    //  Clone current <signal> tag
    var signalNode = (new DOMParser()).parseFromString(oldFileStr, 'text/xml').getElementsByTagName("signal")[0].cloneNode(true);
    newStr += "\n"+(new XMLSerializer()).serializeToString(signalNode);

    //  End xml
    newStr += "\n</tvconf>";

    //  Remove old tv_conf file
    npfunctions.remove_file(filename);

    //  Write new tv_conf file
    SetFileContents(filename, newStr);
}

function sortByChannelNumber(a,b) { return (( parseInt(a.number) < parseInt(b.number)) ? -1 : ((parseInt(a.number) > parseInt(b.number)) ? 1 : 0)); }

function genIconList() {
	var list = new Array();
	var filelist = getFileList(ICON_DIR,  '*.png');
	$(filelist).find('file').each(function() {
		var file = $(this).text();
		if (file != 'tv_default.png')
			list.push(file);
	});
	return list;
}

//
//  Construct channel list -- this method duplicates functionality already existing in the tvConfig object.
//  We should use the method from that object instead
//
function constructChannelList(skipDisabledChannels)
{
    var channelList = new Array();

    //  Begin with channel list from C code
    var tvJSON = evalJSON(getChannelListJSON());

    for(var i=0;i<tvJSON.total;i++)
    {
        var thisChannel = tvJSON.channel[i];
					
		// Analog channels have extra info encoded in their channel name.
		// Format is name:freq|channelNum:position
		channelInfo = String(thisChannel).split(":");

        channelList.push({
			channel  : (getChannelType(String(i)) == "0") ? channelInfo[2] : channelInfo[0],
			name     : channelInfo[0],
            position : i,
            icon     : "",
            originalPosition : String(i), //Original c index file that never changes
            enabled  : true
        });

    }

    //  Get customized channel data from tv_conf.xml
    var fileStr = read_file(DIR_ROOT + "/data/tv_conf.xml");
    var $channels = $((new DOMParser()).parseFromString(fileStr, 'text/xml').getElementsByTagName("channels")[0]);

    //  Go thru each customized channel, find the matching channel in channelList[], and add customized attributes.
    $channels.find("channel").each(function() {

        for(var i=0;i<channelList.length;i++)
        {
            if($(this).attr("number"))
            {
                if($(this).attr("number").toLowerCase() != channelList[i].channel.toLowerCase())
                    continue;
            }

            if($(this).attr("enabled"))
            {
                if($(this).attr("enabled").toLowerCase() == "false")
                    channelList[i].enabled = false;
            }

            channelList[i].name = ($(this).attr("name")) ? $(this).attr("name") : channelList[i].name;
            channelList[i].position = ($(this).attr("position")) ? $(this).attr("position") : i;
            channelList[i].icon = $(this).attr("icon");
        }

    });

    //  If we are building this list for production, pull disabled items before returning
    if(skipDisabledChannels)
    {
        for(var i=0;i<channelList.length;i++)
            if(!channelList[i].enabled)
            {
                channelList.splice(i,1);
                i--;
            }
    }

    channelList.sort(sortByChannelPosition);

    return(channelList);
}

function sortByChannelPosition(a,b) { return ((parseInt(a.position) < parseInt(b.position)) ? -1 : ((parseInt(a.position) > parseInt(b.position)) ? 1 : 0)); }
