import QtQuick 1.0


Image
{
    id: container
    opacity: 0
    source: isFullscreen ? "../images/unFullscreen.png" : "../images/fullscreen.png"
    property bool isFullscreen: false
    property bool showed: false

    signal elementClicked()
    signal showOverlay(bool show)

    Behavior on opacity
    {
        PropertyAnimation
        {
            duration: 500

            onRunningChanged:
            {
                // When we're done, hide it
                if (!running && container.showed)
                {
                    container.showed = false;
                    container.showOverlay(false);
                }
            }
        }
    } // Behavior

    MouseArea
    {
        width: parent.width
        height: parent.height

        onClicked: container.elementClicked();
    }

    SequentialAnimation
    {
        id: timer

        PauseAnimation { duration: 5000 }

        ScriptAction
        {
            script:
            {
                container.showed = true;
                container.opacity = 0;
            }
        }
    }

    function startAnimation()
    {
        timer.stop();
        container.showed = false;
        container.showOverlay(true);
        container.opacity = 0.5;
        timer.start();
    }
}
