/*---------------------------------------------------------------------
	Entertainment Menu Script (True) | true/views/entertainmentMenu/js.js
---------------------------------------------------------------------*/

// Constructor for the Entertainment Menu Object.
function entertainmentObj(name, type, vm) {
	var me = this;

	// App properties.
	me.name = name;
	me.type = type;
	me.vm = vm;

	return me;
}

// Inherit all of the page life-cycle methods.
entertainmentObj.prototype = new app;

// Show the Entertainment View.
entertainmentObj.prototype.show = function trueEntertainmentObjShow() {
	var me = this;
	try {
		// Add functions to the beginning of the view.
		me.preShowHook();
		// Find DOM elements.
		me.bindHTMLElements();
		// Bind listeners to DOM elements.
		me.attachEvents();
		// Internationalize text.
		me.htmlInternationalString();
		// Add functions to the end of the view.
		me.postShowHook();
		
	} catch (e) {
		popError(e);
		return false;
	}

	return true;
};

// Add functions to the beginning of the view.
entertainmentObj.prototype.preShowHook = function trueEntertainmentObjPreShowHook() {
	var me = this;
	return me;
};

// Find DOM elements.
entertainmentObj.prototype.bindHTMLElements = function trueEntertainmentObjBindHTMLElements() {
	var me = this;

	me.$musicBtn = $("#music");
	me.$vodBtn = $("#vod");
	
	return me;
};

// Bind listeners to DOM elements.
entertainmentObj.prototype.attachEvents = function trueEntertainmentObjAttachEvents() {
	var me = this;
	
	me.$musicBtn.bind("mousedown." + me.name, function() {
		me.vm.show("music");	
	});
	me.$vodBtn.bind("mousedown." + me.name, function() {
		me.vm.show("onDemand");
	});

	return me;
};

// Internationalize text.
entertainmentObj.prototype.htmlInternationalString = function trueEntertainmentObjHtmlInternationalString() {
	var me = this;
	
	return me;
};

// Add functions to the end of the view.
entertainmentObj.prototype.postShowHook = function trueEntertainmentObjPostShowHook() {
	var me = this;
	return me;
};

// Clean-up view and hide.
entertainmentObj.prototype.hide = function trueEntertainmentObjHide() {
	var me = this;
	return me;
};