/*---------------------------------------------------------------------
	Landing Page Script (True) | true/views/landingPage/js.js
---------------------------------------------------------------------*/

function trueLandingPageObj(name, type, vm, superClass) {
	var me = this;

	/*----*/
	me.name = name;
	me.type = type;
	me.vm = vm;

	/*----*/
	me.superClass = superClass;
	// me.core = (new (window[superClass])(me.name, me.type, me.vm));
	
    this.recItemTypes = [];
    this.npSlotTotal = 5;
    this.oemSlotTotal = 0;
    
    // Checking for media types in mediaXML then adding that type into the itemTypes array to 
    // avoid situation of crashing when we encounter a media.xml file that doesn't have the data
    // we are looking for. This will only work if media.xml is loaded and parsed synchronously  
    if(mediaXML.musicVideos.length > 0) this.recItemTypes.push("musicVideos");
    if(mediaXML.onDemand.length > 0) this.recItemTypes.push("onDemand");
    
    this.recEngine = new RecEngine({
        "numItems": this.npSlotTotal + this.oemSlotTotal,
        "itemTypes": this.recItemTypes,
        "adSlots": [0, 1],
        "promoSlots": [0]
    });

	return me;
}

// Inherit core prototype for this app
trueLandingPageObj.prototype = new landingPageObj;

trueLandingPageObj.prototype.resetFeaturedItemTypes = function(){
	this.recItemTypes = [];
	
	// Checking for media types in mediaXML then adding that type into the itemTypes array to 
	// avoid situation of crashing when we encounter a media.xml file that doesn't have the data
	// we are looking for. 
	if (mediaXML.musicVideos.length > 0) this.recItemTypes.push("musicVideos");
	if (mediaXML.onDemand.length > 0) this.recItemTypes.push("onDemand");
	
	this.recEngine.setItemTypes(this.recItemTypes);
};

trueLandingPageObj.prototype.showFeaturedItem = function trueLandingPageObjShowFeaturedItem(recItem) {
    var featuredChannel = "";
    switch (recItem.type) {
        case "musicVideos":
            key = "featuredMusic";
            featuredChannel = IDS_LANGUAGE.featuredContent[key];
            break;
        case "onDemand":
            key = "featuredOnDemand";
            featuredChannel = IDS_LANGUAGE.featuredContent[key];
            break;
    }
    
    this.$featuredTitle.html(featuredChannel + ": " + recItem.title).removeClass().addClass(key+"Title");
    this.$featuredImage.css("background", "url("+recItem.thumbnail+") no-repeat center")
    this.$featuredContent.unbind().bind("click." + this.name, recItem.behavior); 
}

/*-------------------------------------------------------------------*/
//@ sourceURL=true/views/landingPage/js.js
