/*---------------------------------------------------------------------
	Main Menu Script (True) | true/views/mainMenu/js.js
---------------------------------------------------------------------*/

// Constructor for the Entertainment Menu Object.
function trueMainMenuObj(name, type, vm, superClass) {
    /*----*/
    this.name = name;
    this.type = type;
    this.vm = vm;

    /*----*/
    this.superClass = superClass;
}

// Inherit all of the page life-cycle methods.
trueMainMenuObj.prototype = new menuView;

// Show the Entertainment View.
trueMainMenuObj.prototype.show = function trueMainMenuObjShow() {
    try {
        // Find DOM elements.
        this.bindHTMLElements();
        // Bind listeners to DOM elements.
        this.attachEvents();
        // Internationalize text.
        this.htmlInternationalString();
    } catch (e) {
        popError(e);
        return false;
    }

    return true;
};

// Find DOM elements.
trueMainMenuObj.prototype.bindHTMLElements = function trueMainMenuObjBindHTMLElements() {
    this.$musicBtn = $("#btnMusic");
    this.$vodBtn = $("#btnOnDemand");
    this.$tvBtn = $("#btnTv");
    this.$ipodBtn = $("#btnIpod");
};

// Bind listeners to DOM elements.
trueMainMenuObj.prototype.attachEvents = function trueMainMenuObjAttachEvents() {
    var me = this;

    if(machineObj.getCountryCode() != 'US'){
        this.$vodBtn.hide();
    }

    this.$musicBtn.bind("mousedown." + me.name, function () {
        viewManager.show("music");
    });
    this.$vodBtn.bind("mousedown." + me.name, function () {
        viewManager.show("onDemand");
    });
    this.$tvBtn.bind("mousedown." + me.name, function () {
        viewManager.show("tv");
    });
    this.$ipodBtn.bind("mousedown." + me.name, function () {
        nsSend2("op=button", "id=ipod");
    });
}; 

