/*---------------------------------------------------------------------
	Registration Script (True) | true/views/registration/js.js
---------------------------------------------------------------------*/

function trueRegisterObj(name, type, vm, superClass) {
	var me = this;

	/*----*/
	me.name = name;
	me.type = type;
	me.vm = vm;

	/*----*/
	me.superClass = superClass;
	// me.core = (new (window[superClass])(me.name, me.type, me.vm));

	return me;
}

// Inherit core prototype for this app
trueRegisterObj.prototype = new registerObj;

/*-------------------------------------------------------------------*/

trueRegisterObj.prototype.preShowHook = function trueRegisterObjPreShowHook() {
    var me = this;
    
    // Alter sliding-box exit routine.
    me.slidingBoxExit = function trueRegisterObjSlidingBoxExit() {
        nsSend2('op=button', 'id=logincnx');
    };
    
    var len = viewManager.history.length; 
    // Matches login, case insensitive
    if (len > 1 && viewManager.history[len-2].search(/^login$/i) != -1) {
        me.slidingBoxExit = function trueRegisterObjSlidingBoxExit() {
            me.vm.showPreviousView();
        };
    }
};

// Override core registration post-show method.
trueRegisterObj.prototype.postShowHook = function trueRegisterObjPostShowHook() {
	var me = this;

	// Bind OK button mouse-down event.
	$('#modalOkButton').bind("mousedown.", function() { $('#errorModal').hide(); });
	// Hide the cancel button.
	me.$cancelButton = $('#cancel').hide();
	$('#conditionsTerms').hide();
	// Override slidingBox updateScrollButtons function.
	me.slidingBox.OverrideUpdateScrollButtons = me.slidingBox.updateScrollButtons;
	me.slidingBox.updateScrollButtons = function trueRegisterObjUpdateScrollButtons() {
		me.slidingBox.OverrideUpdateScrollButtons();
		if (me.slidingBox.currentPage == 5) {
			me.$nextButton.addClass('go');
		} else {
			me.$nextButton.removeClass('go');
		}
	};
	this.termsOfService();

	return me;
};

trueRegisterObj.prototype.baseAttachEvents = trueRegisterObj.prototype.attachEvents;
trueRegisterObj.prototype.attachEvents = function trueRegisterObjAttachEvents() {
    var me = this;

    // Extend and run the registerObj attachEvents method.
    me.baseAttachEvents();

    return me;
};

// Create placeholder for original htmlInternationalString.
trueRegisterObj.prototype.baseHtmlInternationalString = trueRegisterObj.prototype.htmlInternationalString;
// Fill in text for this view.
trueRegisterObj.prototype.htmlInternationalString = function trueRegisterObjHtmlInternationalString() {
    var me = this;

    // Run original/core htmlInternationalString.
    try {
        if (me.baseHtmlInternationalString) {
            me.baseHtmlInternationalString();
        }
    } catch (e) {
        popError(e);
    }

    // Reg-Steps show help information to the new sign-up.
    $('#regSteps1To6').html(IDS_LANGUAGE.register.enterphoneNoforRegistration);
    $('#regSteps2To6').html('');
    $('#regSteps3To6').html(IDS_LANGUAGE.register.selectPasswordImage);
    $('#regSteps4To6').html(IDS_LANGUAGE.register.regSteps4to6);
    $('#regSteps5To6').html(IDS_LANGUAGE.register.enterMinimumWeight);
    $('#regSteps6To6').html(IDS_LANGUAGE.register.clickBacktocorrectEnteries);
    // Use header-text directly from IDS_LANGUAGE,
    // These strings should not contain HTML.
    $('#userIdString').html(this.showXIDlogo(IDS_LANGUAGE.register.createUserid));
    $('#passwordString').html(IDS_LANGUAGE.login.passwordDialog);
    $('#emailString').html(IDS_LANGUAGE.register.registrationSteps2To6);
    $('#dobString').html(IDS_LANGUAGE.register.DOB);
    $('#genderString').html(IDS_LANGUAGE.Gender);
    $('#weightString').html(IDS_LANGUAGE.register["weight"]);
    $('#summaryString').html(IDS_LANGUAGE.register.regSteps6to6);
    /*-------*/
    $('#userIdString1').html(this.showXIDlogo(IDS_LANGUAGE.register.useridString));
    $('#dobString1').html(IDS_LANGUAGE.register.DOBString1);
    $('#passwordString1').html(IDS_LANGUAGE.register.passwordImage);
    $('#privacycontent').html(IDS_LANGUAGE["terms_content"]);
    $('#tgterms').html(IDS_LANGUAGE["trueTermsAndConditions"]);
    $('#xidDescription').html(this.showXIDlogo(IDS_LANGUAGE.register["xidDescription"]));
};

trueRegisterObj.prototype.baseTermsOfService = trueRegisterObj.prototype.termsOfService;
trueRegisterObj.prototype.termsOfService = function trueRegisterObjTermsOfService() {
    var me = this;
    // Run original/core termsOfService.
    try {
        if (me.baseTermsOfService) {
            me.baseTermsOfService(24);
        }
    } catch (e) {
        popError(e);
    }
    me.$termsOfServiceIcon.unbind().bind("mousedown." + me.name, function(e) {
        showModal(IDS_LANGUAGE.register["mustAcceptTermsAndConditions"], 3000);
    });
    me.$termsCloseButton.unbind().bind("mousedown." + me.name, function(e) {
        showModal(IDS_LANGUAGE.register["mustAcceptTermsAndConditions"], 3000);
    });
}; 

/*-------------------------------------------------------------------*/
//@ sourceURL=true/views/registration/js.js
