/*---------------------------------------------------------------------
	Watch Players Script (True) | true/views/watch/js.js
---------------------------------------------------------------------*/

// Override the core watchObj constructor
function trueWatchObj(name, type, vm, superClass) {
	var me = this;
	me.name = name;
	me.type = type;
	me.vm = vm;

	me.superClass = superClass;
	me.core = (new (window[superClass])(me.name, me.type, me.vm));

	me.volume = machineObj.getVolumeLevel();
	me.startTime = 0;
	me.endTime = 0;
	me.videoPlaying = false;
	me.disabled = false;
	me.disableVLCFullscreen = true;

	me.player = me.core.player;
	return me;
}

// Inherit core prototype for this app
trueWatchObj.prototype = new watchObj;

/*-------------------------------------------------------------------*/


trueWatchObj.prototype.bindSkinSpecificElements = function trueWatchObjBindSkinSpecificElements() {
	var me = this;

	
	me.$titleHeader = me.$container.find("#nowPlayingHeader > .subheader");
	me.$title = me.$container.find("#nowPlayingHeader > .title");
	me.$nextTitleHeader = me.$container.find("#upNextHeader > .subheader");
	me.$nextTitle = me.$container.find("#upNextHeader > .title");
	me.$fullCopy = me.$container.find("#fullCopy");
	me.$backToMenuButton = me.$container.find("#backToMenuButton");
	me.$backToMenuText = me.$container.find("#backToMenuText");
	me.$viewHeader = $("#viewPort > header h1");
	me.$fullScreenButton = me.$container.find("#fullScreenButton");

	return me;
};

trueWatchObj.prototype.preShowHook = function trueWatchObjPreShowHook() {
	var me = this;

	$('#paginationDiv').hide();

	watchObj.target.showTitle = function() {
		return me.getTitle();
	};

	return me;
};

trueWatchObj.prototype.postShowHook = function trueWatchObjPostShowHook() {
	var me = this;

	me.$backToMenuButton.unbind().bind('mousedown.' + me.name, function() {
		me.returnToSender();
	});
	
	me.$fullScreenIt.unbind().bind('mousedown.' + me.name, function() {
		//change gui size
		if (guiObj.width != 1182 && guiObj.height != 665){
			guiObj.resizeGuiJs(1182, 665, 0, 103);
			nsSend5("op=size","xpos=0","ypos=103","height=665","width=1182");
		}
	});


	return me;
};

trueWatchObj.prototype.getMainTitle = function trueWatchObjGetMainTitle() {
	// Function to return the watch view title.
	var me = this, st = '', episode = me.getCurrentEpisodeInfo();

	switch (episode.channelType) {
		case "onDemand":
			st = '<strong>' + IDS_LANGUAGE.OnDemandVideos + '</strong><!--/' + episode.channelName + '/-->';
			me.$togglePlaylistButton.hide();
			break;
		case "virtualActive":
			st = '<strong>' + IDS_LANGUAGE.virtualActive + '</strong><!--/' + episode.channelName + '/-->';
			me.$togglePlaylistButton.hide();
			break;
		case "playlist":
		case "music":
		case "musicVideos":
			st = '<strong>' + IDS_LANGUAGE.music + '</strong>: ' + episode.channelName + '';
			// TODO:XXX:FIXME: This is a side-effect.
			me.$togglePlaylistButton.show();
			break;
		case "tv":
			st = '<strong>' + IDS_LANGUAGE.tv.myChannels + '</strong>';
			me.$togglePlaylistButton.hide();
			break;
		case "ipod":
			st = '<strong>' + IDS_LANGUAGE.iPod + '</strong><!--/' + episode.channelName + '/-->';
			me.$togglePlaylistButton.hide();
			break;
		default:
			break;
		}

	return st;
};

trueWatchObj.prototype.getTitle = function trueWatchObjWatchObjGetTitle() {
	// Function to return the watch view title.
	var me = this, st = '', episode = me.getCurrentEpisodeInfo();

	switch (episode.channelType) {
		case "onDemand":
			st = '<div><strong>' + episode.channelName + '</strong></div>' + episode.trackName;
			break;
		case "virtualActive":
			st = '<div><strong>' + IDS_LANGUAGE.mainMenu["virtualActive"] + '</strong></div>' + episode.trackName;
			break;
		case "playlist":
		case "music":
		case "musicVideos":
			st = '<div><strong>' + episode.artistName + '</strong></div>' + episode.trackName;
			break;
		case "tv":
			st = this.player.getChannelName();
			break;
		case "ipod":
			st = '<div><strong>' + episode.artistName + '</strong></div>' + episode.trackName;
			break;
		default:
			break;
	}

	return st;
};

trueWatchObj.prototype.baseHTMLInternationalString = watchObj.prototype.htmlInternationalString;
trueWatchObj.prototype.htmlInternationalString = function trueWatchObjHTMLInternationalString() {
	var me = this;
	me.baseHTMLInternationalString();

	me.$fullCopy.html(IDS_LANGUAGE.watch.fullCopy);
	me.$backToMenuText.html(IDS_LANGUAGE.watch.backToMenu);
	me.$viewHeader.html("<span>" + me.getMainTitle() + "</span>");
};

/*-------------------------------------------------------------------*/
//@ sourceURL=true/views/watch/js.js