function installObj(name, type, vm) {
	this.name = name;
	this.type = type;
	this.vm = vm;
	this.readToInstall = false;
	this.$installPage = null;
	// this.$installerMsg = $("#installerMsg");
}

function runSiphon()
{
    var retval;

    try {
        npfunctions.run("cd "+ DIR_ROOT);          
	    var runProgram = DIR_ROOT +'/bin/siphon';
        retval = runAsync(runProgram, 'siphonsuccess();');
    } catch(e) {
        popError(e);
    }
    return retval;
}

function siphonsuccess()
{
    writeLog('info', 'siphon has finished running from instlaller view');	
	if( athleteObj.get_is_aboard() == 0){
		if(mediaObj.mergeMedia()){
			parseMediaXML();
			writeLog('info', 'New media existed and was merged properly');
		}
		else{
			writeLog('info', 'There was no media to merge in');	
		}
	}
}

installObj.prototype = new app;

installObj.prototype.setArgs = function (args)
{
    // Take mfr, model, name and serial from name value arguments
    // and put into object to support install
    var pairs = args.split (',');
    for (var i = 0; i < pairs.length; i++) {
        var nv = pairs[i].split('='); 
        if (nv[0] == undefined || nv[1] == undefined) {
            continue;
        }
        if (nv[0] == 'mfr') {
           identifyObj.setMfr(nv[1]);
        }
        else if (nv[0] == 'model') {
           identifyObj.setModel(nv[1]);
        }
        else if (nv[0] == 'name') {
           identifyObj.setName(nv[1]);
        }
        else if (nv[0] == 'serial') {
           identifyObj.setSerial(nv[1]);
        }
    }
};

// Override for skin-specific functionality
installObj.prototype.showHookBeforeShow = function() {};

installObj.prototype.show = function show() {
	var me = this;
	athleteObj.set_is_aboard(1);
	this.$installPage = $("#installer");
	this.$installMsg = this.$installPage.find("#installerMsg");
	this.$installerButton = this.$installPage.find("#installerButton").addClass("disabled");
	this.$testNetworkButton = this.$installPage.find("#testNetworkButton").addClass("disabled");
	this.$cancelButton = this.$installPage.find("#cancelButton").bind("click." + me.name, function() {
			// if(confirm('Are you sure?'))
			nsSend2("op=button","id=cnx");
		});
	$('#testNetworkButton').html(IDS_LANGUAGE.install.systemPairing['testNetworkButton']);
	$('#checkForUpdates').html(IDS_LANGUAGE.install.systemPairing['checkForUpdates']);
	$('#installerButton').html(IDS_LANGUAGE.install.systemPairing['installerButton']);
	this.showHookBeforeShow();
	
	try {
		var detect = (identifyObj.isTechnoGym() || identifyObj.isStarTrac() || identifyObj.isMatrix7xi() || identifyObj.isTrue() || identifyObj.isLifeFitnessAddOn() || identifyObj.isN5i() || identifyObj.isMatrix4x3() ) ? true : false;

		var infoStr;
		if (detect) {
			infoStr = '<br /><strong>'+ IDS_LANGUAGE.installCore.detect['auto'] +'</strong><br />'
					+ IDS_LANGUAGE.installCore.detect['mfgName']
					+ identifyObj.getName()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['mfgId']
					+ identifyObj.getMfr()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['model']
					+ identifyObj.getModel()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['serial']
					+ identifyObj.getSerial()
					+ '<br />';
			this.$testNetworkButton.bind("click." + me.name, function() {
				me.testNetwork();
			});
			this.$testNetworkButton.removeClass("disabled");
		} else {
			infoStr = '<big><strong class="fail"><em>'+ IDS_LANGUAGE.installCore.detect['fail'] +'</em></strong><br /></big>';
		}

		configObj.load();
		if (configObj.valid()) {
			infoStr += '<br /><strong>'+ IDS_LANGUAGE.installCore.load['prevInstalled'] +'</strong><br />'
					+ IDS_LANGUAGE.installCore.load['localConf'] +'<br />'
					+ IDS_LANGUAGE.installCore.load['machineId']
					+ configObj.getMid()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['mfgName']
					+ configObj.getName()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['mfgId']
					+ configObj.getMfr()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.detect['model']
					+ configObj.getModel()
					+ '<br />'
					+ IDS_LANGUAGE.installCore.load['macAddress']
					+ configObj.getMac()
					+ '<br />';

			if (identifyObj.getMfr() != configObj.getMfr() || identifyObj.getModel() != configObj.getModel()) {
				infoStr += '<br /><strong>'+ IDS_LANGUAGE.installCore.load['noMatch'] +'</strong><br />';
			} else {
				infoStr += '<br /><strong>'+ IDS_LANGUAGE.installCore.load['yesMatch'] +'</strong><br />';
			}
		} else {
			infoStr += '<br /><strong>'+ IDS_LANGUAGE.installCore.load['neverInstalled'] +'</strong><br />';
		}


		if (this.$installMsg) {
			this.$installMsg.append(infoStr);
		}

		this.showPost();
	} catch (e) {
		//changed from "alert" since these error cannot be internationalized
		writeLog(e);
		return false;
	}
}

installObj.prototype.showPost = function() {};

installObj.prototype.hide = function() {athleteObj.set_is_aboard(0);}

installObj.prototype.testNetwork = function testNetwork() {
	var me = this;
	systemObj.refresh();

    var infoStr = '-------------------<br />'
        +  '<strong>'+ IDS_LANGUAGE.installCore.testNetwork['title'] +'</strong><br />' 
        +  '-------------------<br />';

    if (systemObj.getActiveCount() > 0 ) {
        // display all network interface
        for (idx = 0; idx < systemObj.getActiveCount(); idx++ ) {
                infoStr += IDS_LANGUAGE.installCore.testNetwork['gatewayIp'] +" "+ systemObj.getGatewayIPAddress( idx ) + '<br />'
                        +  IDS_LANGUAGE.installCore.testNetwork['interface']  +" "+  systemObj.getInterface( idx ) + '<br />'
                        +  IDS_LANGUAGE.installCore.testNetwork['adapter'] +" "+  systemObj.getAdapterType( idx ) + '<br />'
                        +  IDS_LANGUAGE.installCore.testNetwork['ipAddress'] +" "+  systemObj.getIPAddress( idx ) + '<br />'
                        +  IDS_LANGUAGE.installCore.load['macAddress']  +" "+  systemObj.getMACAddress( idx ) + '<br /><br />';
        }
    }
    else {
        // display default network interface if there is none.
                infoStr +=  IDS_LANGUAGE.installCore.testNetwork['gatewayIp'] + systemObj.getGatewayIPAddress() + '<br />'
                        +   IDS_LANGUAGE.installCore.testNetwork['interface'] + systemObj.getInterface() + '<br />'
                        +   IDS_LANGUAGE.installCore.testNetwork['adapter'] + systemObj.getAdapterType() + '<br />'
                        +   IDS_LANGUAGE.installCore.testNetwork['ipAddress'] + systemObj.getIPAddress() + '<br />'
                        +   IDS_LANGUAGE.installCore.load['macAddress'] + systemObj.getMACAddress() + '<br /><br />';    
    }

    if (this.$installMsg) {
        this.$installMsg.append(infoStr);
    	this.msgFocus();
   }

    if (systemObj.getActiveCount() > 1) {
       var infoStr = '<strong>'+ IDS_LANGUAGE.installCore['activeCount'] +'<strong><br />';
        if (this.$installMsg) {
          this.$installMsg.append(infoStr);
        	this.msgFocus();
        }
        return;
    }

	var networkTest = {
		gatewaySrc : "http://" + systemObj.getGatewayIPAddress() + "/gateway.xml",
		gatewayOk : false,
		gatewayStr : ''
	};

	$.ajax({
		type:"GET",
		url : networkTest.gatewaySrc,
		dataType : 'xml',
		async : true,
        timeout: 2000,
		success : function(xml) {

			if ($(xml).find("gateway").attr('type') != undefined) {
				networkTest.gatewayOk = true;
				networkTest.gatewayStr = IDS_LANGUAGE.installCore.server['success'];
			} else {
				networkTest.gatewayOk = false;
				networkTest.gatewayStr = IDS_LANGUAGE.installCore.server['badXml'];
			}
			me.testNetwork1(networkTest);
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			networkTest.gatewayOk = false;
			networkTest.gatewayStr = IDS_LANGUAGE.installCore.server['connectError'];
			me.testNetwork1(networkTest);
		}
	});

}

installObj.prototype.testNetwork1 = function(networkTest) {

	networkTest.serverSrc = machineObj.getServerLocation() + "n5iping.jsp";
	networkTest.serverOk = false;
	networkTest.serverStr = '';
	var me = this;

	$.ajax({
		type:"GET",
		url : networkTest.serverSrc,
		dataType : 'text',
		async : true,
        timeout: 2000,
		success : function(data) {

            //Netpulse Core Server version 0.13.14 
            //Last updated August 1, 2011 11:45:41 AM PDT
            if (data.match(/Netpulse Core Server/)) {
                networkTest.serverOk  = true;
                networkTest.serverStr = IDS_LANGUAGE.installCore.server['success'];
            } else {
                networkTest.serverOk  = false;
                networkTest.serverStr = IDS_LANGUAGE.installCore.server['connectError'];
            }
			me.testNetwork2(networkTest);
        },
		error : function(XMLHttpRequest, textStatus, errorThrown) {
            networkTest.serverOk = false;
            networkTest.serverStr = IDS_LANGUAGE.installCore.server['connectError'];
			me.testNetwork2(networkTest);
        }
    });
}

installObj.prototype.testNetwork2 = function(networkTest) {

	var infoStr = '<br />-------------------<br />'
			+ '<strong>'+ IDS_LANGUAGE.installCore['gatewayTest'] +'</strong> <a title="' + networkTest.gatewaySrc + '">' + networkTest.gatewaySrc + '</a> <strong>'+ IDS_LANGUAGE.installCore['result'] +'</strong> ' + networkTest.gatewayStr
			+ '<br /><strong>' + IDS_LANGUAGE.installCore['serverTest']+'</strong> <a title="' + networkTest.serverSrc + '">' + networkTest.serverSrc + '</a> <strong>'+ IDS_LANGUAGE.installCore['result'] +'</strong> ' + networkTest.serverStr
			+ '<br />';

	if (networkTest.gatewayOk & networkTest.serverOk) {
		this.readyToInstall = true;
		var me = this;
		infoStr += '<strong class="pass">'+ IDS_LANGUAGE.installCore['testsPassed'] +'</strong><br />';
		this.$testNetworkButton.unbind("click." + this.name).addClass("disabled");
		this.$installerButton.unbind("click." + this.name).removeClass("disabled");
		this.$installerButton.bind(
				"click." + this.name, function() {
					me.installNetpulse();
				});
	} else {
		infoStr += '<strong class="fail">'+ IDS_LANGUAGE.installCore['oneFail'] +'</strong><br />';
	}

	infoStr += '-------------------<br />';

	if (this.$installMsg) {
		this.$installMsg.append(infoStr);
	}
	this.msgFocus();
}

installObj.prototype.installNetpulse = function installNetpulse() {

//    TEST CODE
//    var serverSrc = 'http://qa-ec2.netpulse.ws/n5iinstall.jsp?mac=00:00:FF:FF:FF:BE&ip=10.3.4.225&mfr=0&model=47&serial=ABCDEFGHI&adapter=wired';

	var serverSrc = machineObj.getServerLocation() + 'n5iinstall.jsp?mac=' + systemObj.getMACAddress() + '&ip=' + systemObj.getIPAddress() 
        + '&mfr=' + identifyObj.getMfr() + '&model=' + identifyObj.getModel() + '&serial=' + identifyObj.getSerial() 
        + '&adapter=' + systemObj.getAdapterType();
	
	
	var installOk = false;
	var machineID, machineXML;

    infoStr = '<strong>'+ IDS_LANGUAGE.installCore['serverInstall'] +'</strong> <a title="' +  serverSrc + '">' +  serverSrc + '</a><br />';

	if (this.$installMsg) {
		this.$installMsg.append(infoStr);
	}

	$.ajax({
		type:"GET",
		url : serverSrc,
		dataType : 'xml',
		async : false,
		timeout:15000,
		success : function(xml) {
			machineID = $(xml).find('response').attr('mid');
			if (machineID != undefined) {
				installOk = true;
				machineXML = $('<div>').append($(xml).find('machine').clone()).html(); 
				serverStr = IDS_LANGUAGE.installCore.server['success'];
			} else {
                serverStr = $(xml).find('response').attr('desc');
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			installOk = false;
			serverStr = IDS_LANGUAGE.installCore.server['connectError'];
		}
	});

	var infoStr;
	if (installOk) {
		//insert new code here  for siphon

		runSiphon();
		configObj.setMfr(identifyObj.getMfr());
		configObj.setModel(identifyObj.getModel());
		configObj.setMid(machineID);
		configObj.setSerial(identifyObj.getSerial());
		configObj.setMac(systemObj.getMACAddress());
		configObj.setName(identifyObj.getName());
		configObj.write();
		
		// 36283305
		// Check for machine.xml data in response and write out machine.xml
		if (machineXML) {
			machineObj.writeConfig(machineXML);
		}

		infoStr = '<strong class="pass">'+ IDS_LANGUAGE.installCore['installSuccess'] +'</strong> new machine ID: ' + machineID + '<br />';
 		
        this.$installerButton.unbind("click." + this.name).addClass("disabled");
		this.$cancelButton.html('done'); //IDS_LANGUAGE.install.tvScan['done']
		this.$cancelButton.bind("click"+ this.name, function () {  nsSend2("op=install","resp=ok"); });
	} else {
		infoStr = '<strong class="fail">'+ IDS_LANGUAGE.installCore['installFail'] +'</strong> server <a title="' +  serverSrc + '">' +  serverStr + '</a><br />';
	}
    writeLog('info', 'installation call: ' + serverSrc + ' resp: ' + serverStr);

	if (this.$installMsg) {
		this.$installMsg.append(infoStr);
	}
	this.msgFocus();
}

installObj.prototype.msgFocus = function(){
	var me = this;
	var scrollHeight = 0;
	if ($.fn.jquery >= "1.6") {
		// jQuery changed the .attr() method starting in 1.6
		scrollHeight = me.$installMsg.prop("scrollHeight");
	} else {
		scrollHeight = me.$installMsg.attr("scrollHeight");
	}
	me.$installMsg.animate({ scrollTop: (scrollHeight - me.$installMsg.height()) + 'px' }, 456, 'linear');
};
