//  Music View Object
function musicObj(name, type, vm)
 {
	this.name = name;
	this.type = type;
	this.vm = vm;
	this.itemsPerPage = 6;
	this.volume = machineObj.getVolumeLevel();
	this.videoPlaying = false; 
	this.disabled = false;
	this.inclCustomPlaylist = true;
	this.showTitle = true;
    this.slidingExit = function slidingExit() { viewManager.show('mainMenu'); };
 }

// inherit streaingObj
musicObj.prototype = new app;


// Init() - if mediaXML is null (not found), disable this page.

musicObj.prototype.init = function()
 {
	if (mediaXML == null) 
           {
		this.disabled = true;
           }
	this.initHookPost();
};
musicObj.prototype.initHookPost = function() {};

// Show()
musicObj.prototype.show = function() {
	var me = this;
	try {
		me.getData();
		me.bindHTMLElements();
		me.bindSkinSpecificElements();
		me.buildLevelsArray();
		me.buildSlideBox();
		me.attachEvents();
		if (me.inclCustomPlaylist)
			$(" li#level_0_item_0 > div > div").removeAttr('style').addClass("playlistLogo");
		$("#videoBackground").hide();
		this.showHookBeforeShow();
		this.htmlInternationalString();
		return true;

	  } catch (e) { popError(e); return false; }
 };

musicObj.prototype.showHookBeforeShow = function() {};

//
musicObj.prototype.getData = function coreMusicObjGetData() {
	var me = this;
	
	me.data = [];
	me.data.items = [];
	if (userCustomPlaylist.items.length > 0) {
		me.inclCustomPlaylist = true;
	}
	if (me.inclCustomPlaylist) {
		// Return a clone of the playlist items, in case we want to modify the play queue independently
		// of the playlist 
		me.data.items.push({
			"items": userCustomPlaylist.items,
			"title": userCustomPlaylist.title,
			"shuffle": userCustomPlaylist.shuffle,
			"type": "playlist"
		});
	}
	for (var i = 0, l = mediaXML.musicVideos.length; i < l; i++) {
		me.data.items.push(mediaXML.musicVideos[i]);
	}
	return me.data;
};

//
musicObj.prototype.bindHTMLElements = function()
 {
	var me = this;

	me.$container = $("#musicView");
	me.$viewPort = me.$container.find("#viewPort");
	me.$vidBrowser = me.$container.find("#vidBrowser");
	me.$title = me.$container.find("h1");
	me.$backButton = me.$container.find("#backButton");
	me.$nextButton = me.$container.find("#nextButton");
	me.$videoContainer = me.$container.find("#videoContainer");
	me.$backToBrowsingButton = me.$videoContainer.find("#backToBrowsing");

	/* Volume Ctrl */
	me.$volUpButton = me.$container.find("#VolUpButton");
	me.$volDnButton = me.$container.find("#VolDnButton");
	
};

//
musicObj.prototype.bindSkinSpecificElements = function() {};


// Set up levels array for slidingBox
musicObj.prototype.buildLevelsArray = function()
{
	var me = this;
	me.data.levels = new Array();
	me.data.levels[0] = {
		drawItem : function(data) 
		{
			if (me.showTitle)
				me.$title.html(IDS_LANGUAGE["music"]);
			return ("<div class='menu_button'><div style='background-image:url("
				+ data.thumbnail
				+ "); background-repeat:no-repeat; background-position:center center;'></div><h2>"
				+ data.title + "</h2></div>");
		},
		attachEvents : function(slideBox, $box)
		{
			me.updateScrollButtonLabels(slideBox);
			
			$box.find("li").each(function()
                                     {
				var val = new Number($(this).find(".item_id").val());

				if (val >= 0)
				{
					$(this).bind("click." + me.name, function()
					{
						if (me.inclCustomPlaylist) {
							var val = new Number($(this).find(".item_id").val());
							
							if (userCustomPlaylist.items.length == 0 && val == 0)
	                        {
								// User is either not logged in, or the user has an empty playlist.
								// Either way, we need to redirect the user to the playlist view
								// to set up the playlist, and NOT try to play the list. The 
								// playlist view already handles the case if user is not logged in.
								viewManager.show('playlist');
								return;
	                        }
						}
						
						me.playChannel();
					});
				}
           });
		},
		itemsPerPage : me.itemsPerPage,
		scrollBack : function(e)
		{
			me.scrollBack(e);
		},
		scrollNext : function(e)
		{
			me.scrollNext(e);
		}
	};
};


//
musicObj.prototype.buildSlideBox = function()
 {
	var me = this;

	me.slideBox = new slidingBox(
		me.data,
		me.$viewPort,
		me.$vidBrowser,
		me.$backButton,
		me.$nextButton,
		1,
		200,
		this.slidingExit,
		$("#cueContainer")
	);
};


//
musicObj.prototype.attachEvents = function()
 {
	var me = this;

	me.$backToBrowsingButton.bind("click." + me.name, function()
       {
		me.stopVideo();
		if (me.showTitle);
			me.$title.html(IDS_LANGUAGE["music"]);
	});

	if (me.$nextVideoButton && me.$nextVideoButton.length > 0)
	me.$nextVideoButton.bind("click." + me.name, function() { me.nextVideo(); });

	if (me.$prevVideoButton && me.$prevVideoButton.length > 0)
		me.$prevVideoButton.bind("click." + me.name, function() { me.prevVideo(); });

	if (me.$backButton && me.$backButton.length > 0)
		me.$backButton.bind("click." + me.name, function() { me.goBack(); });
};


//
musicObj.prototype.goBack = function()
 {
	var me = this;
	$("#videoBackground").hide();
	if (me.videoPlaying)
            {
		me.stopVideo();
		if (me.showTitle()) 
			me.$title.html(IDS_LANGUAGE["music"]);
		$("header").removeClass();
            }
        else
		me.slideBox.upOneLevel();
		
};

//If a video is playing when the user hits the scroll back button, stop the video and DONT scroll back.
musicObj.prototype.scrollBack = function(e) 
{
	var me = this;

	if (me.videoPlaying) 
          {
		me.stopVideo();
		return false;
	 }

	me.slideBox.scrollBack();
	me.updateScrollButtonLabels(me.slideBox);
};


//
musicObj.prototype.scrollNext = function(e)
 {
	var me = this;
	if (me.videoPlaying)
       {
		me.stopVideo();
		return false;
	}

	me.slideBox.scrollNext();
	me.updateScrollButtonLabels(me.slideBox);
};


//In TG update the header buttons when a video starts
musicObj.prototype.playChannel = function()
 {
	var me = this;

	me.slideBox.chosenItems[1] = 0;
    var currentChannel = me.slideBox.data.items[me.slideBox.chosenItems[0]];
    if (currentChannel.shuffle) // if shuffle is on
        currentChannel.items.sort(randOrd);

	me.play();
    
};


//
musicObj.prototype.updateScrollButtonLabels = function(slideBox)
 {
	var me = this;

	var htmlStr = "";
	var $p = me.$backButton.find("p").css("opacity", "0");

	switch (slideBox.currentLevel)
        {
	case 0:
		htmlStr = (slideBox.currentLeft >= 0) ? "Menu" : "Back";
		break;

	case 1:
		htmlStr = (slideBox.currentLeft >= 0) ? "Genres" : "Back";
		break;

	case 2:
		htmlStr = (slideBox.currentLeft >= 0) ? slideBox.data.items[slideBox.chosenItems[0]].title : "Back";
		break;

	default:
		popError("defaulted!");
		break;
	}

	setTimeout(function()
              {
		$p.html(htmlStr).css("opacity", "1");
              }, 150);
};



//
musicObj.prototype.play = function(item) 
{
	var me = this;
	$("#videoBackground").show();
	 
	if (me.errorTimeout)
        clearTimeout(me.errorTimeout);

	stopVideo(this.$videoContainer);
	var currentChannel = me.slideBox.data.items[me.slideBox.chosenItems[0]];
	var currentEpisode = currentChannel.items[me.slideBox.chosenItems[1]];

    if (currentEpisode.type.toUpperCase() == 'GATEWAY') {
        currentEpisode.location = "rtsp://" + systemObj.getGatewayIPAddress() + "/" + currentEpisode.location;
    }
    writeLog ('info', 'episode location ' + currentEpisode.location);

	if (me.showTitle)
		me.$title.html("Music Videos - " + currentEpisode.title);

	var playerString = '<object type="video/mpeg" id="videoPlayer" data="'
			+ currentEpisode.location
			+ '"><param name="data_type" value="ondemand"></object>';

	if (me.playTimeout)
	clearTimeout(me.playTimeout);

	me.playTimeout = setTimeout(function()
        {
		playVideo(me.$videoContainer, playerString);
	}, 500);

	me.videoPlaying = true;
};


//
musicObj.prototype.stopVideo = function()
 {
	var me = this;

	me.killVideo();

	if (me.errorTimeout)
        clearTimeout(me.errorTimeout);
};


//
musicObj.prototype.killVideo = function()
 {
	if (!this.$videoContainer)
		return;

	stopVideo(this.$videoContainer);

	this.videoPlaying = false;
};


//
musicObj.prototype.mediaError = function()
 {
	var me = this;

	if (me.errorTimeout)
	clearTimeout(me.errorTimeout);

	me.killVideo();

	me.$videoContainer.append(IDS_LANGUAGE["videoUnavilable"]);

	me.errorTimeout = setTimeout(function() 
         {
		me.nextVideo();
	 }, 3 * 1000);
};

//
musicObj.prototype.nextVideo = function() 
{
	var me = this;

        var currentChannel = me.slideBox.data.items[me.slideBox.chosenItems[0]];
	var currentEpisode = currentChannel.items[me.slideBox.chosenItems[1]];
	this.saveImpression();
	// If we are at the end of the current channel list.
	me.slideBox.chosenItems[1] = (parseInt(me.slideBox.chosenItems[1]) >= currentChannel.items.length - 1) ? 0 : parseInt(me.slideBox.chosenItems[1]) + 1;

	me.play();
};


//
musicObj.prototype.prevVideo = function()
 {
	var me = this;

	var currentChannel = me.slideBox.data.items[me.slideBox.chosenItems[0]];
	
	var currentEpisode = currentChannel.items[me.slideBox.chosenItems[1]];
	this.saveImpression();
	// If we are at the end of the current channel list.
	me.slideBox.chosenItems[1] = (parseInt(me.slideBox.chosenItems[1]) == 0) ? (currentChannel.items.length - 1) : parseInt(me.slideBox.chosenItems[1]) - 1;

	me.play();
};



// Populate the playlist content if the user is not logged in.
musicObj.prototype.toggleCustomPlaylist = function()
 {
	var me = this;

	if (window.userIsLoggedIn != false && userCustomPlaylist.items.length > 0)
            {
		me.$editPlaylistBtn.show();
		me.$watchPlaylistBtn.show();
 	    }
        else if (window.userIsLoggedIn != false && userCustomPlaylist.items.length <= 0)
		me.$createPlaylistBtn.show();
	else
		me.$createPlaylistBtn.show();
};



musicObj.prototype.hide = function()
 {
	$("#videoBackground").hide();
	this.stopVideo();
	
 };




musicObj.prototype.showVideoAd = function() { };


musicObj.prototype.saveImpression = function()
{		
	var playTime = guiObj.getVideoTimeElapsedInSeconds();

	if(playTime <= 0)
		return;
	
	if (adMan.ads['music_preroll_video'].videoBool) {
		if (viewManager.currentView.name == 'music') {
			adMan.ads['music_preroll_video'].addVideoImpression(playTime);
		}
		guiObj.resetVideoTimeElapsedInSeconds();
		return;
	}
  
	var impression = new mediaImpression(this.getCurrentVideoId(), playTime);
	impressions.addImpression(impression);
	
	guiObj.resetVideoTimeElapsedInSeconds();
}

musicObj.prototype.getCurrentVideoId = function()
{
	
    var currentChannel = this.slideBox.data.items[this.slideBox.chosenItems[0]];
    var currentEpisode = currentChannel.items[this.slideBox.chosenItems[1]];
 
    return(currentEpisode.id);
}

musicObj.prototype.htmlInternationalString = function ()
{
  $('#more').html(IDS_LANGUAGE["more"]);
}


