/*=====================================================================
	Summary Bar (CORE) | views/summaryBar/js.js
=====================================================================*/

// Constructor for the Summary Bar Object.
function summaryBarObj(name, type, vm) {
	var me = this;

	// App properties.
	me.name = name;
	me.type = type;
	me.vm = vm;

	// HTML/DOM elements.
	me.$container = null;
	me.$infoHeader = null;
	me.$title = null;
	me.$infoContent = null;

	return me;
}

// Inherit all of the page life-cycle methods.
summaryBarObj.prototype = new app;

// Show the User Accounts View.
summaryBarObj.prototype.show = function coreSummaryBarObjShow() {
	var me = this;
	try {
		// Add functions to the beginning of the view.
		me.preShowHook();
		// Find DOM elements.
		me.bindHTMLElements();
		// Bind listeners to DOM elements.
		me.attachEvents();
		// Internationalize text.
		me.htmlInternationalString();
		// Get user data.
		me.getData();
		// Display user data.
		me.displayData();
		// Add functions to the end of the view.
		me.postShowHook();
	} catch (e) {
		popError(e);
		return false;
	}

	return true;
};

// Add functions to the beginning of the view.
summaryBarObj.prototype.preShowHook = function coreSummaryBarObjPreShowHook() {

	var me = this;
	return me;
};

// Find DOM elements.
summaryBarObj.prototype.bindHTMLElements = function coreSummaryBarObjBindHTMLElements() {
	var me = this;

	me.$container = $('div#summaryBarView');
	me.$infoHeader = me.$container.find('header#summaryBarHeader');
	me.$title = me.$infoHeader.find('h1.title');
	me.$summaryBarContent = me.$container.find('#summaryBarContent');

	return me;
};



// Bind listeners to DOM elements.
summaryBarObj.prototype.attachEvents = function coreSummaryBarObjAttachEvents() {
	var me = this;
	return me;
};

// Internationalize text.
summaryBarObj.prototype.htmlInternationalString = function coreSummaryBarObjHtmlInternationalString() {
	var me = this;
	return me;
};

// Get user data.
summaryBarObj.prototype.getData = function coreSummaryBarObjGetData() {
	var me = this;
	return me;
};

// Display user data.
summaryBarObj.prototype.displayData = function coreSummaryBarObjDisplayData() {
	var me = this;
	return me;
};

// Add functions to the end of the view.
summaryBarObj.prototype.postShowHook = function coreSummaryBarObjPostShowHook() {
	var me = this;
	return me;
};

// Clean-up view and hide.
summaryBarObj.prototype.hide = function coreSummaryBarObjHide() {
	var me = this;
	return me;
};

